<?php

/**
 * mion actions.
 *
 * @package    sam3
 * @subpackage mion
 * @author     Robert Górecki
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class mionActions extends myActions {

    public function preExecute() {
        $perm = ($this->getUser()->checkPermission('mion', 'edit') == 1) ? true : false;

        if (!$perm || !in_array('mion', ModulPeer::getEnabled())) {
            $this->forwardSecure();
        }
    }

    public function executeIndex(sfWebRequest $request) {
        $c = new Criteria();
        $c = $this->addSortCrit('MionPeer', $c);

        if ($request->hasParameter('kategoria')) {
            $kategoria = MionKategoriaPeer::retrieveByPk($request->getParameter('kategoria'));
            if ($kategoria) {
                $c->add(MionKategoriaMapPeer::KATEGORIA_ID, $kategoria->getId());
            }
            $this->filter = $kategoria;
        }
        $c->addJoin(MionKategoriaMapPeer::MION_ID, MionPeer::ID);

        if ($request->isMethod('post')) {
            $values = $request->getParameter('szukaj');
            $this->getUser()->setAttribute('szukaj', $values, 'mion');
        } else {
            $values = $this->getUser()->getAttribute('szukaj', array(), 'mion');
            if ($request->hasParameter('pokaz')) {//anuluj szukanie
                $this->getUser()->setAttribute('szukaj', array(), 'mion');
                $values = array();
            }
        }
        $kategoria = (isset($values['kategoria'])) ? $values['kategoria'] : false;
        $slowo = (isset($values['slowo'])) ? $values['slowo'] : false;
        $wiek = (isset($values['wiek'])) ? $values['wiek'] : false;
        $stopien = (isset($values['stopien'])) ? $values['stopien'] : false;
        $przyczyna = (isset($values['przyczyna'])) ? $values['przyczyna'] : false;
        $od = (isset($values['od'])) ? $values['od'] : false;
        $do = (isset($values['do'])) ? $values['do'] : false;

        if ($kategoria) {
            $c->add(MionKategoriaMapPeer::KATEGORIA_ID, $kategoria);
        }

        if ($slowo) {
            $c1 = $c->getNewCriterion(MionPeer::TEMAT, '%' . $slowo . '%', Criteria::LIKE);
            $c2 = $c->getNewCriterion(MionPeer::TRESC, '%' . $slowo . '%', Criteria::LIKE);
            $c3 = $c->getNewCriterion(MionPeer::ZAJAWKA, '%' . $slowo . '%', Criteria::LIKE);
            $c2->addOr($c3);
            $c1->addOr($c2);
            $c->add($c1);
        }
        if ($wiek) {
            switch ($wiek) {
                case '1': $wiek_col = MionPeer::WIEK1;
                    break;
                case '2': $wiek_col = MionPeer::WIEK2;
                    break;
                case '3': $wiek_col = MionPeer::WIEK3;
                    break;
                case '4': $wiek_col = MionPeer::WIEK4;
                    break;
                case '5': $wiek_col = MionPeer::WIEK5;
                    break;
                default: $wiek_col = false;
            }
            if ($wiek_col) {
                $c->add($wiek_col, 1);
            }
        }
        if ($stopien) {
            switch ($stopien) {
                case '1': $stopien_col = MionPeer::NP_ZNACZNY;
                    break;
                case '2': $stopien_col = MionPeer::NP_UMIARKOWANY;
                    break;
                case '3': $stopien_col = MionPeer::NP_LEKKI;
                    break;
                default: $stopien_col = false;
            }
            if ($stopien_col && $wiek != '1') {
                $c->add($stopien_col, 1);
            }
        }
        if ($przyczyna) {
            switch ($przyczyna) {
                case '1': $przyczyna_col = MionPeer::PRZYCZYNA_WZROK;
                    break;
                case '2': $przyczyna_col = MionPeer::PRZYCZYNA_MOWA;
                    break;
                case '3': $przyczyna_col = MionPeer::PRZYCZYNA_RUCH;
                    break;
                case '4': $przyczyna_col = MionPeer::PRZYCZYNA_INNE;
                    break;
                default: $przyczyna_col = false;
            }
            if ($przyczyna_col) {
                $c->add($przyczyna_col, 1);
            }
        }

        if (isset($values['od']) && $values['od'] != "" && isset($values['do']) && $values['do'] != "") {
            $c4 = $c->getNewCriterion(MionPeer::CREATED_AT, $values['od'] . ' 00:00:00', Criteria::GREATER_EQUAL);
            $c5 = $c->getNewCriterion(MionPeer::CREATED_AT, $values['do'] . ' 23:59:59', Criteria::LESS_EQUAL);
            $c4->addAnd($c5);
            $c->add($c4);
        } elseif (isset($values['od']) && $values['od'] != "") {
            $c6 = $c->getNewCriterion(MionPeer::CREATED_AT, $values['od'] . ' 00:00:00', Criteria::GREATER_EQUAL);
            $c->add($c6);
        } elseif (isset($values['do']) && $values['do'] != "") {
            $c7 = $c->getNewCriterion(MionPeer::CREATED_AT, $values['do'] . ' 23:59:59', Criteria::LESS_EQUAL);
            $c->add($c7);
        }
        if (isset($values['status']) && $values['status'] != "") {
            $c->add(MionPeer::ZATWIERDZONA, $values['status']);
        }

        $permGlobal = $this->getUSer()->checkPermission('mion_global', 'edit') == 1 ? true : false;
        $showType = $this->getUser()->getAttribute('show', null, 'mion');
        if (!$permGlobal || $showType == 'mine') {
            $c->add(MionPeer::UZYTKOWNIK_ID, $this->getUser()->getId());
        }
        $c->addGroupByColumn(MionKategoriaMapPeer::MION_ID);
        $c->setDistinct();
        $pager = new sfPropelPager('MionKategoriaMap', 15);
        $pager->setCriteria($c);
        $pager->setPage($this->getRequestParameter('strona', 1));
        $pager->setPeerCountMethod('doCountDistinctDocs');
        $pager->init();
        $this->pager = $pager;
    }

    public function executeNowy(sfWebRequest $request) {
        $this->form = new MionForm();
        $this->getUser()->setAttribute('dir', 'ten/katalog/nie/powinien/istniec');
        $c = new Criteria();
        $c->addAscendingOrderByColumn(MionKategoriaPeer::NAZWA);
        $this->kategorie = MionKategoriaPeer::doSelect($c);
        $this->selected = array();

        //sprawdza czy sa jakies kategorie
        $this->ile_kat = MionKategoriaPeer::doCount(new Criteria());
    }

    public function executeZapisz(sfWebRequest $request) {
        $this->forward404Unless($request->isMethod('post'));
        $this->form = new MionForm();
        $this->processForm($request, $this->form);

        $c = new Criteria();
        $c->addAscendingOrderByColumn(MionKategoriaPeer::NAZWA);
        $this->kategorie = MionKategoriaPeer::doSelect($c);
        $this->setTemplate('nowy');
        //sprawdza czy sa jakies kategorie
        $this->ile_kat = MionKategoriaPeer::doCount(new Criteria());
    }

    public function executeEdytuj(sfWebRequest $request) {
        $id = $request->getParameter('id');
        $this->forward404Unless($this->mion = MionPeer::retrieveByPk($id));
        if (!$this->mion->canBeEditedBy($this->getUser())) {
            $this->forwardSecure();
        }
        $this->form = new MionForm($this->mion);

        //kategorie
        $c = new Criteria();
        $c->addAscendingOrderByColumn(MionKategoriaPeer::NAZWA);
        $this->kategorie = MionKategoriaPeer::doSelect($c);
        //domyslnie zaznaczone te wybrane
        $c = new Criteria();
        $c->add(MionKategoriaMapPeer::MION_ID, $id);
        $pow_kat = MionKategoriaMapPeer::doSelect($c);
        $selected = array();
        if ($pow_kat) {
            foreach ($pow_kat as $kat) {
                $selected[$kat->getKategoriaId()] = 'on';
            }
        }
        $this->selected = $selected;
    }

    public function executeAktualizuj(sfWebRequest $request) {
        $this->forward404Unless($request->isMethod('post'));
        $id = $request->getParameter('mion[id]');
        $this->forward404Unless($this->mion = MionPeer::retrieveByPk($id));
        if (!$this->mion->canBeEditedBy($this->getUser())) {
            $this->forwardSecure();
        }
        $this->form = new MionForm($this->mion);
        $this->processForm($request, $this->form);

        //kategorie
        $c = new Criteria();
        $c->addAscendingOrderByColumn(MionKategoriaPeer::NAZWA);
        $this->kategorie = MionKategoriaPeer::doSelect($c);

        $this->setTemplate('edytuj');
    }

    private function processForm($request, $form) {
        $this->getContext()->getConfiguration()->loadHelpers(array('Upload', 'Funkcje'));

        $params = $request->getParameter('mion');

        $safe_params = cleanValuesFromForm($form, $params);

        $this->form->bind($safe_params, $request->getFiles('mion'));

        $kategorie = $request->getParameter('kategorie');
        if (count($kategorie) == 0) {
            $kat_error = true;
            $this->getUser()->setFlash('error', 'Musisz wybrać co najmniej jedną kategorię dla dokumentu, aby go zapisać!');
        }

        if ($form->isValid() && !isset($kat_error)) {
            
            $values = $form->getValues();
            // wyczyszczenie katalogu zajawek
            if(array_key_exists('grafika', $values) && !empty($values['grafika']))
            {
                $stare_grafiki_zajawki = glob($values['grafika']->getPath().'\*');
                foreach($stare_grafiki_zajawki as $file)
                {
                    @unlink($file);
                }
            }
            
            $mion = $form->save();
            if ($form->isNew()) {
                $mion->setUzytkownikId($this->getUser()->getId());
                $mion->save();
            }
            $id = $mion->getId();

            //grafika
            if ($values['grafika'] != NULL && $values['grafika_delete'] == '') {
                //usun poprzednie obrazki
                $path_file = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '/zajawki/';
                if (is_dir($path_file)) {
                    Functions::rrmdir($path_file);
                }

                $filename = $mion->getGrafika();
                $file = $path_file . $filename;

                if (is_file($file)) { 
                    Functions::wygenerujMiniaturkiPrzyUploadzie($path_file, $filename . $extension, $path_file, array('mini', 'thumb', 'normal'), 'graf_config_', $filename . $extension);
                }
            }
            if ($values['grafika_delete'] == 'on') {
                $mion->setGrafika(''); //usuwa z bazy
                $mion->save();

                //i z dysku
                $path = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '/zajawki';
                if (is_dir($path)) {
                    Functions::rrmdir($path);
                }
            }

            //usuwa poprzednie kategorie
            $c = new Criteria();
            $c->add(MionKategoriaMapPeer::MION_ID, $id);
            MionKategoriaMapPeer::doDelete($c);
            //i zapisuje nowe
            foreach ($kategorie as $key => $value) {
                $nowa_kat = new MionKategoriaMap();
                $nowa_kat->setMionId($id);
                $nowa_kat->setKategoriaId($key);
                $nowa_kat->save();
            }
            $mion->setZatwierdzona(0);
            $mion->save();

            $this->getUser()->setFlash('notice', 'Pomyślnie zapisano dokument');
            $this->redirect('mion/edytuj?id=' . $mion->getId());
        }
        //zapamietaj zaznaczone kategorie
        $kategorie = $request->getParameter('kategorie');
        $selected = array();
        if (count($kategorie) != 0) {
            foreach ($kategorie as $key => $value) {
                $selected[$key] = 'on';
            }
        }
        $this->selected = $selected;
    }

    public function executeThumbnailSave(sfWebRequest $request) {
        if (!$request->isMethod('post')) {
            $this->redirect('mion/index');
        }

        if ($request->isMethod('post')) {

            $nazwa = $_GET['filename'];
            $size = $request->getParameter('size');
            $repl = sfConfig::get('sf_upload_dir');

            $preg_pattern = "/(.*)uploads/";
            $filename = preg_replace($preg_pattern, $repl, $nazwa);

            $thumb = str_replace('zajawki/orginal_', 'zajawki/' . $size . '_', $filename);

            $t_file = fopen($thumb, 'w');
            fwrite($t_file, $GLOBALS["HTTP_RAW_POST_DATA"]);
            fclose($t_file);

            $watermark_config = UstawieniePeer::getProperties('graf_config_watermark');
            if (isset($watermark_config['show']) && $watermark_config['show'] == 1) {
                //znak wodny
                $margin = $watermark_config['margin'];
                $pos = $watermark_config['pos'];
                $watermark_src = sfConfig::get('sf_upload_dir') . "/" . $watermark_config['file'];
                UploadFileForm::addWatermark($thumb, $watermark_src, null, $pos, $margin);
            }

            $ref = $request->getReferer();
            $this->redirect($ref ? $ref : '@homepage');
        }
    }

    public function executeUsun(sfWebRequest $request) {

        $this->getContext()->getConfiguration()->loadHelpers(array('Funkcje'));
        $id = $request->getParameter('id');
        $this->forward404Unless($mion = MionPeer::retrieveByPk($id));
        if (!$mion->canBeDeletedBy($this->getUser())) {
            $mion->setZatwierdzona(3);
            $mion->save();

            $this->getUser()->setFlash('notice', 'Przekazano dokument do usunięcia');
            $this->redirect('mion/index');
        }

        $mion_pub = MionPubPeer::retrieveByPk($id);
        if ($mion_pub) {
            //usun info z tabeli mapujacej kategorie
            $c = new Criteria();
            $c->add(MionKategoriaMapPubPeer::MION_ID, $id);
            MionKategoriaMapPubPeer::doDelete($c);
            //usun zalaczniki
            $c = new Criteria();
            $c->add(MionZalacznikPubPeer::MION_ID, $id);
            $zalaczniki = MionZalacznikPubPeer::doSelectJoinZalacznik($c);

            foreach ($zalaczniki as $zp) {
                $zp->getZalacznik()->delete();
            }

            $path = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '_pub';
            if (is_dir($path)) {
                Functions::rrmdir($path);
            }
            $mion_pub->delete();
        }
        //usun info z tabeli mapujacej kategorie
        $c = new Criteria();
        $c->add(MionKategoriaMapPeer::MION_ID, $id);
        MionKategoriaMapPeer::doDelete($c);
        //usun zalaczniki
        $c = new Criteria();
        $c->add(MionZalacznikPeer::MION_ID, $id);
        $zalaczniki = MionZalacznikPeer::doSelectJoinZalacznik($c);

        foreach ($zalaczniki as $zal) {
            $zal->getZalacznik()->delete();
        }

        $path = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id;
        if (is_dir($path)) {
            Functions::rrmdir($path);
        }
        $mion->delete();

        $this->getUser()->setFlash('notice', 'Pomyślnie usunięto dokument!');
        sfCacheManager::clearCache('mion');
        $this->redirect('mion/index');
    }

    public function executePublikuj(sfWebRequest $request) {
        $id = $request->getParameter('id');
        $this->forward404Unless($mion = MionPeer::retrieveByPK($id));
        if (!$mion->canBePublishedBy($this->getUser())) {
            $mion->setZatwierdzona(4);
            $mion->save();

            $this->getUser()->setFlash('notice', 'Przekazano dokument do publikacji');
            $this->redirect('mion/edytuj?id=' . $mion->getId());
        }

        if ($mion) {
            $mion->kopiujDoPub();
            $this->getUser()->setFlash('notice', 'Pomyślnie opublikowano dokument!');

            sfCacheManager::clearCache('mion');

            $this->redirect('mion/edytuj?id=' . $mion->getId());
        } else {
            $this->redirect('mion/index');
        }
    }

    public function executeOdpublikuj(sfWebRequest $request) {
        $id = $request->getParameter('id');
        $this->forward404Unless($mion = MionPeer::retrieveByPK($id));
        $mion_pub = MionPubPeer::retrieveByPK($id);
        if (!$mion->canBePublishedBy($this->getUser())) {
            $mion->setZatwierdzona(6);
            $mion->save();

            $this->getUser()->setFlash('notice', 'Przekazano dokument do usunięcia z publikacji');
            $this->redirect('mion/edytuj?id=' . $mion->getId());
        }

        if ($mion_pub) {
            $mion->usunZPub();
            $this->getUser()->setFlash('notice', 'Pomyślnie odpublikowano dokument!');

            sfCacheManager::clearCache('mion');

            $this->redirect('mion/edytuj?id=' . $mion->getId());
        } else {
            if ($mion) {
                $this->getUser()->setFlash('error', 'Dokument nie został jeszcze opublikowany!');
                $this->redirect('mion/edytuj?id=' . $mion->getId());
            } else {
                $this->redirect('mion/index');
            }
        }
    }

    public function executeUstawienia(sfWebRequest $request) {

        //create dir for images/files
        $dir = sfConfig::get("sf_upload_dir") . "/mion/config";
        if (!is_dir($dir)) {
            mkdir($dir, 0775, true);
        }
        $this->getUser()->setAttribute('dir', '/uploads/mion/config');

        $perm = ($this->getUser()->checkPermission('mion_conf', 'edit') == 1) ? true : false;
        if (!$perm) {
            $this->forwardSecure();
        }

        $this->form = new komunikatForm();
        $portal_id = sfConfig::get('portal')->getId();
        $komunikat = KomunikatPeer::retrieveByPk('mion_welcome_msg', $portal_id);
        $tresc = ($komunikat) ? $komunikat->getTresc() : 'hello';
        $this->form->setDefault('msg', $tresc);

        if ($request->isMethod('post')) {
            $msg = $request->getParameter('msg');

            $komunikat = KomunikatPeer::retrieveByPk('mion_welcome_msg', $portal_id);
            if (!$komunikat) {
                $komunikat = new Komunikat();
            }
            $komunikat->setNazwa('mion_welcome_msg');
            $komunikat->setTresc($msg);
            $komunikat->setJezykId(1);
            $komunikat->save();
            $komunikat->setPortalId($portal_id);
            $this->getUser()->setFlash('notice', 'Pomyślnie zapisano zmiany!');

            sfCacheManager::clearCache('mion');
            $this->redirect('mion/ustawienia');
        }
    }

    public function executeOdrzuc(sfWebRequest $request) {
        $id = $request->getParameter('id');
        $this->forward404Unless($mion = MionPeer::retrieveByPk($id));
        if ($mion->canBePublishedBy($this->getUser())) {
            $mion->setZatwierdzona(5);
            $mion->save();
            $this->getUser()->setFlash('notice', 'Pomyślnie odrzucono dokument');
        }
        $this->redirect('mion/edytuj?id=' . $mion->getId());
    }

    public function executeBatchActions(sfWebRequest $request) {
        if ($request->isMethod('post')) {
            $action = $request->getParameter('batch_action');
            $elements = $request->getParameter('ids');
            if (empty($action)) {
                $this->getUser()->setFlash('error', 'Wybierz akcję do wykonania.');
                $this->redirect('mion/index');
            } elseif (empty($elements)) {
                $this->getUser()->setFlash('error', 'Wybierz przynajmniej jeden element.');
                $this->redirect('mion/index');
            } else {
                switch ($action) {
                    case 'publish':
                        $this->batchPublish($elements);
                        break;
                }
                $this->getUser()->setFlash('notice', 'Pomyślnie wykonano akcję.');
                sfCacheManager::clearCache('mion');
                $this->redirect('mion/index');
            }
        } else {
            $this->redirect('mion/index');
        }
    }

    public function batchPublish($obiekty) {
        foreach ($obiekty as $obj) {
            $mion = MionPeer::retrieveByPk($obj);
            if ($mion) {
                if (!$mion->canBePublishedBy($this->getUser())) {
                    $mion->setZatwierdzona(4);
                    $mion->save();
                } else {
                    $mion->kopiujDoPub();
                }
            }
        }
    }

    /**
     * Sets show type, all or only current user documents
     *
     * @param   sfWebRequest $request
     */
    public function executeSetShow(sfWebRequest $request) {
        $this->getUser()->setAttribute('show', $request->getParameter('show'), 'mion');

        $this->redirect('mion/index');
    }

    /**
     * metoda czyszczaca i budujaca indexy Lucene
     * @author      Tomasz Glowinski, 2014
     */
    public function executeRegenerateLuceneIndex() {
        $mod_short = 'mion';

        // czyszczenie calego idexu
        Functions::clearLuceneIndex($mod_short);

        // ponowne indexowanie kazdego artykulu
        $c = new Criteria();
        $rs = MionPubPeer::doSelect($c);

        foreach ($rs as $obj)
            $obj->updateLuceneIndex();

        sfContext::getInstance()->getConfiguration()->loadHelpers(array('I18N'));
        $this->getUser()->setFlash('notice', __('Zindeksowano ' . count($rs) . ' artykułów.'));
        $this->redirect('mion/index');
    }

    /**
     * metoda generujaca na nowo miniaturki (mini, thumb, normal)
     * @param       sfWebRequest $request 
     * @param       bool forced czy nadpisywac istniejace pliki
     * @param       bool update_pub czy aktualizowac artykuly opublikowane
     * @author      Tomasz Glowinski, 2013
     */
    public function executeRegenerateThumbnails(sfWebRequest $request) {
        // USTAWIENIA ----------------------------------------------------------
        // sciezka do katalogu artykulow (uwaga! jesli niepusty musi konczyc sie symbolem /)
        $source_dir = sfConfig::get('sf_upload_dir') . '/mion/';

        // przedrostek kazdego artykulu (uwaga! musi konczyc sie symbolem *)
        $art_prefix = 'doc_*';

        // podkatalog z plikami oryginalnymi (uwaga! jesli niepusty musi konczyc sie symbolem /)
        $source_subdir = 'zajawki/';

        // uzyj podanej konfiguracji
        $use_config = 'graf_config_';

        // wygeneruj miniatury o podanych przedrostkach (uwaga! przedrostki musza miec swoja konfiguracje)
        $gen_thumbnails = array('mini', 'thumb', 'normal', 'max');

        // ---------------------------------------------------------------------
        // czas rozpoczecia procesu
        if (!$this->getUser()->hasAttribute('regenerateThumbnails-start_time') || !($this->getUser()->getAttribute('regenerateThumbnails-start_time')))
            $this->getUser()->setAttribute('regenerateThumbnails-start_time', microtime(true));

        // czas ostatniej przerwy wykonywania skryptu
        if (!$this->getUser()->hasAttribute('regenerateThumbnails-last_break_time') || !($this->getUser()->getAttribute('regenerateThumbnails-last_break_time')))
            $this->getUser()->setAttribute('regenerateThumbnails-last_break_time', microtime(true));

        // ilosc przerw
        if (!$this->getUser()->hasAttribute('regenerateThumbnails-breaks') || !($this->getUser()->getAttribute('regenerateThumbnails-breaks')))
            $this->getUser()->setAttribute('regenerateThumbnails-breaks', 1);

        // maksymalny czas na wykonanie partii
        $max_time = ini_get('max_execution_time') - 5;

        // jakosc generowanych grafik
        $quality = sfConfig::get('app_miniatures_quality');

        // tryb wymuszonej regeneracji (true spowoduje nadpisanie istniejacych miniatur
        $forced = $request->getParameter('forced', false);

        // tryb aktualizacji plikow publikowanych
        $update_pub = false; // i tak jest aktualizowany pub
        // ilosc zregenerowanych grafik
        $gen_count = $this->getUser()->getAttribute('regenerateThumbnails-gen_count', 0);

        // lista blednych grafik
        $errors = $this->getUser()->getAttribute('regenerateThumbnails-errors', array());

        // wyszukuje katalogow artykulow
        $news_folders = glob($source_dir . $art_prefix, GLOB_MARK | GLOB_ONLYDIR);

        // ile pierwszych katalogow pominac jako zregenerowane
        $regenerated = $this->getUser()->getAttribute('regenerateThumbnails-regenerated', -1);

        // Watermark      
        $watermark_config = UstawieniePeer::getProperties('graf_config_watermark');

        // petla po katalogach
        foreach ($news_folders as $key => $folder) {
            // pomijam zregenerowane wczesniej katalogi
            if ($key <= $regenerated)
                continue;

            // sprawdzam, czy zostal utworzony katalog zrodlowy z zajawkami (nie = nie ma grafik)
            $folder_path = $folder . $source_subdir;
            if (!is_dir($folder_path))
                continue;

            // wyszukuje zaladowane obrazki zajawkowe
            $images = preg_grep('/.+mini_.+$|.+normal_.+$|.+thumb_.+$|.+orginal_.+$/', glob($folder_path . '*.{jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG}', GLOB_BRACE), PREG_GREP_INVERT);

            // petla po obrazkach
            foreach ($images as $img_key => $img) {
                try {
                    // katalog docelowy miniaturek
                    $temp_path = $folder_path;
                    $pub_path = str_replace('temp', 'pub', $temp_path);
                    $file_name = str_replace($folder_path, '', $img);

                    // Biorę obrazek typu orginal
                    $source_img = str_replace($temp_path, $temp_path . 'orginal_', $img);

                    // tworzenie katalogu z miniaturkami w razie potrzeby
                    if (!is_dir($temp_path))
                        mkdir($pathname, 0775, true);

                    // generowanie miniaturek
                    foreach ($gen_thumbnails as $thumbnail_type) {

                        $thumbnail = $temp_path . (($thumbnail_type == 'max') ? '' : $thumbnail_type . '_') . $file_name;
                        if (!file_exists($thumbnail) || $forced) {
                            $sizes = UstawieniePeer::getProperties($use_config . $thumbnail_type);
                            if (count($sizes) < 2) {
                                $sizes = sfConfig::get('app_size_' . $thumbnail_type);
                            }

                            $gfx = new sfImage($source_img);
                            $gfx->thumbnail($sizes['x'], $sizes['y'], array_key_exists('behaviour', $sizes) ? $sizes['behaviour'] : 'scale');
                            $gfx->setQuality($quality);
                            $gfx->saveAs($thumbnail);

                            // nakładanie wasermarka
                            if (isset($watermark_config['show']) && $watermark_config['show'] == 1) {
                                $margin = $watermark_config['margin'];
                                $pos = $watermark_config['pos'];
                                $watermark_src = sfConfig::get('sf_upload_dir') . "/" . $watermark_config['file'];
                                UploadFileForm::addWatermark($thumbnail, $watermark_src, null, $pos, $margin);
                            }

                            $gen_count++;

                            if ($update_pub) {
                                if (!is_dir($pub_path))
                                    mkdir($pub_path, 0775, true);

                                $thumbnail_pub = $pub_path . (($thumbnail_type == 'max') ? '' : $thumbnail_type . '_') . $file_name;
                                if (!file_exists($thumbnail) || $forced) {
                                    copy($thumbnail, $thumbnail_pub);
                                    $gen_count++;
                                }
                            }
                        }
                    }
                } catch (sfStopException $e) {
                    // nothnig
                } catch (Exception $e) {
                    $errors[] = $e->getMessage();
                }
            }

            // fragmentaryzacja wykonywania skryptu
            if ($key + 1 % 10000 == 0 || (microtime(true) - $this->getUser()->getAttribute('regenerateThumbnails-last_break_time') > $max_time)) {
                $this->getUser()->setAttribute('regenerateThumbnails-regenerated', $key);
                $this->getUser()->setAttribute('regenerateThumbnails-errors', $errors);
                $this->getUser()->setAttribute('regenerateThumbnails-gen_count', $gen_count);
                $this->getUser()->setAttribute('regenerateThumbnails-last_break_time', microtime(true));
                $this->getUser()->setAttribute('regenerateThumbnails-breaks', $this->getUser()->getAttribute('regenerateThumbnails-breaks') + 1);
                $this->redirect($_SERVER['PHP_SELF']);
            }
        }

        $execution_time = (microtime(true) - $this->getUser()->getAttribute('regenerateThumbnails-start_time')) . ' sek';
        $execution_parts = $this->getUser()->getAttribute('regenerateThumbnails-breaks');
        $this->getUser()->setAttribute('regenerateThumbnails-regenerated', null);
        $this->getUser()->setAttribute('regenerateThumbnails-errors', null);
        $this->getUser()->setAttribute('regenerateThumbnails-gen_count', null);
        $this->getUser()->setAttribute('regenerateThumbnails-start_time', null);
        $this->getUser()->setAttribute('regenerateThumbnails-breaks', null);

        if ($gen_count > 0 && empty($errors))
            $this->getUser()->setFlash('notice', 'Pomyślnie wygenerowano miniatury (ilość: ' . $gen_count . ', czas wykonania: ' . $execution_time . ' w ' . $execution_parts . ' etapach)');
        elseif (count($errors) > 0)
            $this->getUser()->setFlash('error', 'Wystąpiły błędy podczas generowania miniatur (ilość wygenerowanych: ' . $gen_count . ', błędy: ' . implode(', ', $errors) . ')');
        else
            $this->getUser()->setFlash('error', 'Nie ma plików do wygenerowania przy wybranych ustawieniach');

        $this->redirect('frontend/index');
    }

}
