<?php use_helper('Javascript', 'Form')?>
<div id="tab-container-1">
    <ul class="info_tabs" id="tab-container-1-nav">
        <li><a href="#tab0"><?php echo __('Dane podstawowe'); ?></a></li>
        <li><a href="#tab1"><?php echo __('Zajawka'); ?></a></li>
        <li><a href="#tab2"><?php echo __('Opcje'); ?></a></li>
        <li><a href="#tab3"><?php echo __('Kategorie'); ?></a></li>
        <li><a href="#tab4"><?php echo __('Załączniki'); ?></a></li>
    </ul>

    <div id="tab0" class="tab">
        <?php echo $form->renderHiddenFields() ?>
        <fieldset class="editor">
            <legend><?php echo __('Dane podstawowe'); ?></legend>
            <table class="mion_form">
                <tr><th><?php echo $form['temat']->renderLabel()?></th><td><?php echo $form['temat']->renderError()?> <?php echo $form['temat']->render()?></td></tr>
                <tr><th></th><td class="help"><?php echo $form['temat']->renderHelp()?></td></tr>

                <tr><th><?php echo $form['identyfikator']->renderLabel()?></th><td><?php echo $form['identyfikator']->renderError()?> <?php echo $form['identyfikator']->render(array('class' => 'input'))?></td></tr>
                <tr><th></th><td class="help"><?php echo $form['identyfikator']->renderHelp()?></td></tr>

                <tr><th><?php echo $form['stan_prawny']->renderLabel()?></th><td><?php echo $form['stan_prawny']->renderError()?> <?php echo $form['stan_prawny']->render(array('class' => 'input'))?></td></tr>
                <tr><th></th><td class="help"><?php echo $form['stan_prawny']->renderHelp()?></td></tr>

                <tr><td colspan="2"><?php echo $form['tresc']->renderError()?> <div class="required"><?php echo $form['tresc']->render()?></div></td></tr>

            </table>
        </fieldset>
    </div>
    <div id="tab1" class="tab">
        <fieldset class="editor">
            <legend><?php echo __('Zajawka'); ?></legend>
            <table class="mion_form">
                <tr>
                    <th><?php echo $form['zajawka']->renderLabel()?></th>
                    <td><?php echo $form['zajawka']->renderError()?> <?php echo $form['zajawka']->render(array('style' => 'width:400px'))?></td>
                </tr>
                <tr>
                    <th>&nbsp;</th>
                    <td class="help"><?php echo $form['zajawka']->renderHelp()?></td>
                </tr>
                <tr>
                    <th><?php echo $form['grafika']->renderLabel()?></th>
                    <td><?php echo $form['grafika']->renderError()?> <?php echo $form['grafika']->render()?></td>
                </tr>
                <tr>
                    <th>&nbsp;</th>
                    <td class="help"><?php echo $form['grafika']->renderHelp() ?></td>
                </tr>
                <tr>
                    <th>&nbsp;</th>
                    <td>
                        <?php if($form->getObject()->getGrafika()) {
                            use_javascript('functions.js','last');
                            $size = UstawieniePeer::getProperties('graf_config_mini');
                            include_partial('frontend/editPix',array(
                                'nazwa'     => 'mini',
                                'size_x'    => $size['x'],
                                'size_y'    => $size['y'],
                                'name'      => __('Miniaturka'),
                                'in_file'   => image_path('../uploads/mion/doc_'.$form['id']->getValue().'/zajawki/orginal_'.$form['grafika']->getValue()),
                                'out_url'   => url_for("mion/thumbnailSave?size=mini"),
				'return_url' => url_for('mion/edytuj?id='.$form['id']->getValue())
                            ));

                            $size = UstawieniePeer::getProperties('graf_config_thumb');
                            include_partial('frontend/editPix',array(
                                'nazwa'     => 'thumb',
                                'size_x'    => $size['x'],
                                'size_y'    => $size['y'],
                                'name'      => __('Zajawka listy'),
                                'in_file'   => image_path('../uploads/mion/doc_'.$form['id']->getValue().'/zajawki/orginal_'.$form['grafika']->getValue()),
                                'out_url'   => url_for("mion/thumbnailSave?size=thumb"),
				'return_url' => url_for('mion/edytuj?id='.$form['id']->getValue())
                            ));

                            $size = UstawieniePeer::getProperties('graf_config_normal');
                            include_partial('frontend/editPix',array(
                                'nazwa'     => 'normal',
                                'size_x'    => $size['x'],
                                'size_y'    => $size['y'],
                                'name'      => __('Zajawka treści'),
                                'in_file'   => image_path('../uploads/mion/doc_'.$form['id']->getValue().'/zajawki/orginal_'.$form['grafika']->getValue()),
                                'out_url'   => url_for("mion/thumbnailSave?size=normal"),
				'return_url' => url_for('mion/edytuj?id='.$form['id']->getValue())
                            ));
                        } ?>
                    </td>
                </tr>
            </table>
        </fieldset>
    </div>
    <div id="tab2" class="tab">

        <?php if(Comments::showInForms('mion')):?>
        <fieldset class="editor">

            <legend><?php echo __('Komentarz'); ?></legend>
            <table class="mion_form">
                <tr>
                    <th>
                            <?php echo $form['komentarz']->renderLabel() ?>
                    </th>
                    <td>
                            <?php echo $form['komentarz']->renderError() ?>
                            <?php echo $form['komentarz']->render() ?>
                    </td>
                </tr>
                <tr><th></th><td class="help"><?php echo $form['komentarz']->renderHelp()?></td></tr>
            </table>
        </fieldset>
    
        <?php endif;?>

        <fieldset class="editor">

            <legend><?php echo __('Opcje'); ?></legend>
            <table class="mion_form_options">
                <tr><th><?php echo $form['wiek1']->renderLabel()?></th><td><?php echo $form['wiek1']->renderError()?> <?php echo $form['wiek1']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['wiek2']->renderLabel()?></th><td><?php echo $form['wiek2']->renderError()?> <?php echo $form['wiek2']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['wiek3']->renderLabel()?></th><td><?php echo $form['wiek3']->renderError()?> <?php echo $form['wiek3']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['wiek4']->renderLabel()?></th><td><?php echo $form['wiek4']->renderError()?> <?php echo $form['wiek4']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['wiek5']->renderLabel()?></th><td><?php echo $form['wiek5']->renderError()?> <?php echo $form['wiek5']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['np_lekki']->renderLabel()?></th><td><?php echo $form['np_lekki']->renderError()?> <?php echo $form['np_lekki']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['np_umiarkowany']->renderLabel()?></th><td><?php echo $form['np_umiarkowany']->renderError()?> <?php echo $form['np_umiarkowany']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['np_znaczny']->renderLabel()?></th><td><?php echo $form['np_znaczny']->renderError()?> <?php echo $form['np_znaczny']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['przyczyna_wzrok']->renderLabel()?></th><td><?php echo $form['przyczyna_wzrok']->renderError()?> <?php echo $form['przyczyna_wzrok']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['przyczyna_mowa']->renderLabel()?></th><td><?php echo $form['przyczyna_mowa']->renderError()?> <?php echo $form['przyczyna_mowa']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['przyczyna_ruch']->renderLabel()?></th><td><?php echo $form['przyczyna_ruch']->renderError()?> <?php echo $form['przyczyna_ruch']->render(array('value' => '1'))?></td></tr>
                <tr><th><?php echo $form['przyczyna_inne']->renderLabel()?></th><td><?php echo $form['przyczyna_inne']->renderError()?> <?php echo $form['przyczyna_inne']->render(array('value' => '1'))?></td></tr>
                <tr><th></th><td class="help"><?php echo __('Wybierz opcje opisujące dokument'); ?></td></tr>
            </table>
        </fieldset>
    </div>
    <div id="tab3" class="tab">
        <fieldset class="editor">
            <legend><?php echo __('Kategorie'); ?></legend>
            <table class="mion_form_options">
                <?php foreach($kategorie as $kat):?>
                <tr><th><?php echo label_for('kategorie_'.$kat->getId(), $kat->getNazwa())?></th><td><?php echo checkbox_tag('kategorie['.$kat->getId().']', '1', isset($selected[$kat->getId()])?'checked="checked"':'')?></td></tr>
                <?php endforeach;?>
                <tr><th></th><td class="help"><?php echo $form['mion_kategoria_map_list']->renderHelp()?></td></tr>
            </table>
        </fieldset>
    </div>
    <div id="tab4" class="tab">
        <fieldset class="editor">
            <legend><?php echo __('Załączniki'); ?></legend>
            <?php if(!$form->isNew()):?>
            <iframe style="width: 620px; height: 400px;" src="<?php echo url_for('mionZalacznik/index?obj_id='.$form->getObject()->getId())?>"></iframe>
            <?php else:?>
            <div style="color: red;"><?php echo __('Aby dodać załączniki najpierw zapisz dokument'); ?></div>
            <?php endif;?>
        </fieldset>
    </div>

</div>
<div class="right">
    <?php include_partial('akcje', array('form' => $form))?>
</div>
<script type="text/javascript">
    var tabber1 = new Yetii({id: 'tab-container-1', tabclass: 'tab' });
</script>
