<?php

/**
 * mionKategorie actions.
 *
 * @package    sam3
 * @subpackage mionKategorie
 * @author     Robert Górecki
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class mionKategorieActions extends myActions
{

  public function preExecute()
  {
    $perm = ($this->getUser()->checkPermission('mion', 'edit') == 1) ? true : false;
    
    if (!$perm || !in_array('mion', ModulPeer::getEnabled()))
    {
      $this->forwardSecure();
    }
  }

  public function executeIndex(sfWebRequest $request)
  {
    $c = new Criteria();
    $c->addAscendingOrderByColumn(MionKategoriaPeer::KOLEJNOSC);
    $this->kategoria_list = MionKategoriaPeer::doSelect($c);
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new MionKategoriaForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));
    $this->form = new MionKategoriaForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {

    $this->forward404Unless($kategoria = MionKategoriaPeer::retrieveByPk($request->getParameter('id')));
    $this->form = new MionKategoriaForm($kategoria);
  }

  public function executeUpdate(sfWebRequest $request)
  {

    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($kategoria = MionKategoriaPeer::retrieveByPk($request->getParameter('id')));

    $this->form = new MionKategoriaForm($kategoria);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($kategoria = MionKategoriaPeer::retrieveByPk($request->getParameter('id')));

    if ($kategoria->countMionKategoriaMaps())
    {
      $this->getUser()->setFlash('error', 'Nie można usunąć kategorii z przypisanymi dokumentami');
    }
    else
    {
      try
      {
        $kategoria->delete();
        $this->getUSer()->setFlash('notice', 'Pomyślnie usunięto kategorię.');
      }
      catch (Exception $e)
      {
        $this->getUser()->setFlash('error', 'Nie udało się usunąć kategorii.');
      }
    }
    $this->redirect('mionKategorie/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {

    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if ($form->isNew())
      {
        //ustaw max kolejnosc dla nowej kategorii
        $c = new Criteria();
        $kat = MionKategoriaPeer::doSelect($c);
        foreach ($kat as $k)
        {
          $k->setKolejnosc($k->getKolejnosc() + 1);
          $k->save();
        }

        $form->getObject()->setKolejnosc(0);
      }
      $kategoria = $form->save();

      $this->getUser()->setFlash('notice', 'Pomyślnie zapisano kategorię.');
      $this->redirect('mionKategorie/edit?id=' . $kategoria->getId());
    }
  }

  public function executeZamienkolejnosc(sfWebRequest $request)
  {
    $first = MionKategoriaPeer::retrieveByPK($request->getParameter('up'));
    $second = MionKategoriaPeer::retrieveByPK($request->getParameter('down'));
    if ($first && $second)
    {
      $first_pos = $first->getKolejnosc();
      $second_pos = $second->getKolejnosc();
      $first->setKolejnosc($second_pos);
      $second->setKolejnosc($first_pos);
      $first->save();
      $second->save();
    }
    $c = new Criteria();
    $c->addAscendingOrderByColumn(MionKategoriaPeer::KOLEJNOSC);
    $kategoria_list = MionKategoriaPeer::doSelect($c);

    return $this->renderPartial('tabela', array('kategoria_list' => $kategoria_list));
  }

}
