<?php

/**
 * mionZalacznik actions.
 *
 * @package    sam3
 * @subpackage mionZalacznik
 * @author     Robert Górecki
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class mionZalacznikActions extends myActions {

    public function preExecute() {
        sfConfig::set('sf_web_debug', false);

        $perm = ($this->getUser()->checkPermission('mion', 'edit') == 1) ? true : false;

        if (!$perm || !in_array('mion', ModulPeer::getEnabled())) {
            $this->forwardSecure();
        }
    }

    public function executeIndex(sfWebRequest $request) {
        $this->setLayout('default');
        $mion_id = $request->getParameter('obj_id');

        $this->form = new fileUploadForm();

        $this->form->setValidator('file_name', new sfValidatorString(array('trim' => 'true')));
        $this->form->setValidator('file_desc', new sfValidatorString(array('trim' => 'true', 'required' => false)));

        $this->form->setValidator('file_src', new ciValidatorFile(array(
            'mime_types' => 'zalaczniki',
            'max_size' => 5242880,
                ), array(
            'mime_types' => 'Nieprawidłowy typ pliku!',
            'max_size' => 'Maksymalny rozmiar załącznika to 5MB!'
        )));

        $this->form->setDefault('obj_id', $mion_id);

        $c = new Criteria();
        $c->add(MionZalacznikPeer::MION_ID, $mion_id);
        $c->addAscendingOrderByColumn(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC);
        $this->zalaczniki = MionZalacznikPeer::doSelectJoinZalacznik($c);


        if ($request->isMethod('post')) {
            $obj_id = $request->getParameter('file[obj_id]');
            $mion_id = $request->getParameter('file[obj_id]');

            $this->form->bind($request->getParameter('file'), $request->getFiles('file'));

            if ($this->form->isValid()) {
                $values = $this->form->getValues();

                $id = $values['obj_id'];

                $file = $values['file_src'];
                $filename = sha1($file->getOriginalName());
                $extension = $file->getOriginalExtension();

                $zalacznik = new Zalacznik();
                $zalacznik->setNazwa($values['file_name']);
                $zalacznik->setNazwaPliku($filename . $extension);
                $zalacznik->setSciezka('/mion/doc_' . $id . '/zalaczniki/');
                $zalacznik->setOpis($values['file_desc']);
                $zalacznik->setRozmiarPliku($file->getSize());
                $zalacznik->save();

                //ustaw max kolejnosc dla nowego zal
                $c = new Criteria();
                $c->add(MionZalacznikPeer::MION_ID, $id);
                $zal = MionZalacznikPeer::doSelect($c);
                foreach ($zal as $z) {
                    $z->setZalacznikKolejnosc($z->getZalacznikKolejnosc() + 1);
                    $z->save();
                }

                $mion_zalacznik = new MionZalacznik();
                $mion_zalacznik->setMionId($id);
                $mion_zalacznik->setZalacznikId($zalacznik->getId());
                $mion_zalacznik->setZalacznikKolejnosc(0);
                $mion_zalacznik->save();

                if (!is_dir(sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '/zalaczniki')) {
                    mkdir(sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '/zalaczniki', 0775);
                }
                $file->save(sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '/zalaczniki/' . $filename . $extension);

                /* usuwam zalaczniki ktore byly spakowane do pobrania */
                $mask = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $id . '/zalaczniki/*_zalaczniki.zip';
                array_map("unlink", glob($mask));

                $this->redirect('mionZalacznik/index?obj_id=' . $mion_id);
            }


            $c = new Criteria();
            $c->add(MionZalacznikPeer::MION_ID, $mion_id);
            $c->addAscendingOrderByColumn(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC);
            $this->zalaczniki = MionZalacznikPeer::doSelectJoinZalacznik($c);
        }
    }

    public function executeUsun(sfWebRequest $request) {
        $id = $request->getParameter('id');

        $this->forward404Unless($zalacznik = ZalacznikPeer::retrieveByPk($id));

        $criteria = new Criteria();
        $criteria->add(MionZalacznikPeer::ZALACZNIK_ID, $id);
        $this->forward404Unless($mion_zalacznik = MionZalacznikPeer::doSelectOne($criteria));

        $del_zal = $zalacznik->getNazwaPliku();
        $path = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $mion_zalacznik->getMionId() . '/zalaczniki/' . $del_zal;

        $zalacznik->delete();

        /* usuwam zalaczniki ktore byly spakowane do pobrania */
        $mask = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $mion_zalacznik->getMionId() . '/zalaczniki/*_zalaczniki.zip';
        array_map("unlink", glob($mask));

        unlink($path);

        $this->redirect('mionZalacznik/index?obj_id=' . $mion_zalacznik->getMionId());
    }

    public function prepareDownload($outFilename, $ext) {
        header('Content-Type: application/' . $ext . ';charset=UTF-8');
        header('Content-Disposition: attachment;filename=' . $outFilename);
        error_reporting(1);
        return sfView::HEADER_ONLY;
    }

    public function executeDownload(sfWebRequest $request) {

        $zal_id = $request->getParameter('zal_id');
        $doc_id = $request->getParameter('doc_id');

        $zalacznik = ZalacznikPeer::retrieveByPK($zal_id);
        $zalacznik_src = $zalacznik->getNazwaPliku();
        $zalacznik_name = $zalacznik->getNazwa();
        $zalacznik_name = str_replace(' ', '_', $zalacznik_name);
        $file_name = explode('.', $zalacznik_src);
        $this->prepareDownload($zalacznik_name . '.' . $file_name[count($file_name) - 1], $file_name[count($file_name) - 1]);
        readfile(sfConfig::get('sf_upload_dir') . '/mion/doc_' . $doc_id . '/zalaczniki/' . $zalacznik_src);

        return sfView::NONE;
    }

    public function executeZamienkolejnosc(sfWebRequest $request) {
        $first = MionZalacznikPeer::retrieveByPK($request->getParameter('doc_id'), $request->getParameter('up'));
        $second = MionZalacznikPeer::retrieveByPK($request->getParameter('doc_id'), $request->getParameter('down'));
        if ($first && $second) {
            $first_pos = $first->getZalacznikKolejnosc();
            $second_pos = $second->getZalacznikKolejnosc();
            $first->setZalacznikKolejnosc($second_pos);
            $second->setZalacznikKolejnosc($first_pos);
            $first->save();
            $second->save();
        }
        
        /* usuwam zalaczniki ktore byly spakowane do pobrania */
        $mask = sfConfig::get('sf_upload_dir') . '/mion/doc_' . $request->getParameter('doc_id') . '/zalaczniki/*_zalaczniki.zip';
        array_map("unlink", glob($mask));

        $this->redirect('mionZalacznik/index?obj_id=' . $request->getParameter('doc_id'));
    }

}
