<?php

class MionSzukajAdvForm extends sfForm
{

    public function configure()
    {
        $this->setWidgets(array(
            'query' => new sfWidgetFormInput(),
            'data_od' => new sfWidgetFormInputDateRich(),
            'data_do' => new sfWidgetFormInputDateRich(),
            'wiek' => new sfWidgetFormSelect(array('choices' => array('' => 'dowolny', '1' => '0-15 lat', '2' => '16-17 lat', '3' => '18-24 lata', '4' => '25 lat', '5' => '26 i więcej lat'))),
            'stopien' => new sfWidgetFormSelect(array('choices' => array('' => 'dowolny', '1' => 'Znaczny', '2' => 'Umiarkowany', '3' => 'Lekki'))),
            'przyczyna' => new sfWidgetFormSelect(array('choices' => array('' => 'dowolna', '1' => 'Narząd wzroku', '2' => 'Narząd słuchu lub mowy', '3' => 'Narząd ruchu', '4' => 'Inna'))),
        ));

        $this->setValidators(array(
            'query' => new sfValidatorString(array('max_length' => 255, 'trim' => true, 'required' => false)),
            'data_od' => new sfValidatorDate(array('required' => false)),
            'data_do' => new sfValidatorDate(array('required' => false)),
            'wiek' => new sfValidatorPass(),
            'stopien' => new sfValidatorPass(),
            'przyczyna' => new sfValidatorPass(),
        ));

        $this->widgetSchema->setLabels(array(
            'data_od' => 'Data dodania od: ',
            'data_do' => 'Data dodania do:',
            'wiek' => 'Wiek',
            'stopien' => 'Stopien niepełnosprawności',
            'przyczyna' => 'Przyczyna niepełnosprawności',
        ));

        $this->widgetSchema->setHelps(array(
            'data_od' => 'Format daty: rok-miesiąc-dzień.',
            'data_do' => 'Format daty: rok-miesiąc-dzień.',
        ));

        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $hash_id = $this->getOption('hash_id');
        $this->getWidgetSchema()->setNameFormat($this->getWidgetSchema()->getNameFormat().( $hash_id ? '_'.$hash_id : ''));

        sfContext::getInstance()->getConfiguration()->loadHelpers(array('I18N'));
        $this->setDefault('query', __(sfConfig::get('app_search_prompt')));

        $this->widgetSchema->setNameFormat('search[%s]');
        $hash_id = $this->getOption('hash_id');
//        $this->getWidgetSchema()->setNameFormat('search[%s]');        
        $this->getWidgetSchema()->setIdFormat('search'.( $hash_id ? '_'.$hash_id : '').'_%s');
        
        $this->setRequiredFields();
        
        $this->disableCSRFProtection();
    }

}
?>