<?php

/**
 * mion actions.
 *
 * @package    sam3
 * @subpackage mion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class mionActions extends sfActions
{

    public function preExecute()
    {
        if(!in_array('mion', ModulPeer::getEnabled()))
        {
            $this->redirect('@homepage');
        }
        $culture = $this->getUser()->getCulture();
        $response = $this->getResponse();
        Functions::setAllMetasFromDb('mion', $response, $culture);
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeIndex(sfWebRequest $request)
    {
        $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/mion/';

        $this->getUser()->getAttributeHolder()->remove('srch_mion');

        if($request->hasParameter('kategoria'))
        {
            $c = new Criteria();
            $kategoria = MionKategoriaPeer::retrieveByPk($request->getParameter('kategoria'));
            $this->category = $kategoria;
            if($kategoria)
            {
                $c->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $kategoria->getId());
                $this->filter = $kategoria->getId();
            }
            $this->filter = 'wszystkie';
            $c->addJoin(MionKategoriaMapPubPeer::MION_ID, MionPubPeer::ID);
            $c->addDescendingOrderByColumn(MionPubPeer::CREATED_AT);
            $c->addGroupByColumn(MionKategoriaMapPubPeer::MION_ID);
            $c->setDistinct();
            $pager = new sfPropelPager('MionKategoriaMapPub', sfConfig::get('app_pages'));
            $pager->setCriteria($c);
            $pager->setPage($this->getRequestParameter('strona', 1));
            $pager->setPeerCountMethod('doCountDistinctDocs');
            $pager->init();
            $this->pager = $pager;
        }
        else
        {
            $tresc_strony_glownej = KomunikatPeer::retrieveByPk('mion_welcome_msg', sfConfig::get('portal')->getId());
            $this->tresc_strony_glownej = ($tresc_strony_glownej) ? $tresc_strony_glownej->getTresc() : '';
        }
    }

    public function executeDownload(sfWebRequest $request)
    {
        $preview = $request->getParameter('preview');
        $file_id = $request->getParameter('file_id');
        $doc_id = $request->getParameter('doc_id');
        if($preview == 1)
        {
            $zalacznik = MionZalacznikPeer::retrieveByPK($doc_id, $file_id);
            $zalacznik_src = $zalacznik->getZalacznik();
            $file_src = $zalacznik_src->getNazwaPliku();
            ZalacznikPeer::prepareFile($zalacznik_src);
            readfile(sfConfig::get('sf_upload_dir').'/mion/doc_'.$doc_id.'/zalaczniki/'.$file_src);
        }
        else
        {
            $zalacznik = MionZalacznikPubPeer::retrieveByPK($doc_id, $file_id);
            $zalacznik_src = $zalacznik->getZalacznikPub();
            $file_src = $zalacznik_src->getNazwaPliku();
            ZalacznikPeer::prepareFile($zalacznik_src);
            readfile(sfConfig::get('sf_upload_dir').'/mion/doc_'.$doc_id.'_pub/zalaczniki/'.$file_src);
            ZalacznikPeer::Pobran($file_id);
        }
        exit();
    }

    public function executeDownloadZip(sfWebRequest $request)
    {

        $id = $request->getParameter('id');
        $c_zalaczniki = new Criteria();

        if($request->hasParameter('preview'))
        {
            $dokument = MionPeer::retrieveByPK($id);
            $c_zalaczniki->add(MionZalacznikPeer::MION_ID, $id);
            $c_zalaczniki->addAscendingOrderByColumn(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC);
            $zalaczniki_list = $dokument->getMionZalaczniksJoinZalacznik($c_zalaczniki);
            $file_path = sfConfig::get('sf_upload_dir').'/mion/doc_'.$id.'/zalaczniki/';
        }
        else
        {
            $dokument = MionPubPeer::retrieveByPK($id);
            $c_zalaczniki->add(MionZalacznikPubPeer::MION_ID, $id);
            $c_zalaczniki->addAscendingOrderByColumn(MionZalacznikPubPeer::ZALACZNIK_KOLEJNOSC);
            $zalaczniki_list = $dokument->getMionZalacznikPubsJoinZalacznikPub($c_zalaczniki);
            $file_path = sfConfig::get('sf_upload_dir').'/mion/doc_'.$id.'_pub/zalaczniki/';
        }
        $zipname = Functions::slugify($dokument->getTemat(), 255).'_zalaczniki.zip';

        if(!is_file($file_path.$zipname))
        {
            $zip = new ZipArchive;
            $zip->open($file_path.$zipname, ZipArchive::CREATE);
            foreach($zalaczniki_list as $file)
            {
                if($request->hasParameter('preview'))
                {
                    $zalacznik = $file->getZalacznik();
                }
                else
                {
                    $zalacznik = $file->getZalacznikPub();
                }
                $filename = $zalacznik->getNazwaPliku();
                $old_name = explode('.', $filename);
                $ext = ($old_name[1]);
                $nazwa = trim($zalacznik->getNazwa());
                $new_name = str_pad($file->getZalacznikKolejnosc(), 2, '0', STR_PAD_LEFT).'_'.Functions::slugify($nazwa, 255).'.'.$ext;

                $zip->addFile($file_path.$filename, pathinfo($new_name, PATHINFO_BASENAME));
            }
            $zip->close();
        }

        if(!$request->hasParameter('preview'))
        {
            foreach($zalaczniki_list as $file):
                $zalacznik = $file->getZalacznikPub();
                ZalacznikPeer::Pobran($zalacznik->getId());
            endforeach;
        }

        ///Then download the zipped file.
        ZalacznikPeer::prepareDownloadZip($zipname);
        readfile($file_path.$zipname);
        exit();
    }

    public function executePokaz(sfWebRequest $request)
    {
        $this->preview_mode = false;
        $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/mion/';

        $id = $request->getParameter('id');
        $this->mion = MionPubPeer::retrieveByPk($id);
        $this->forward404Unless($this->mion);

        $c = new Criteria();
        $c->add(MionZalacznikPubPeer::MION_ID, $id);
        $c->addAscendingOrderByColumn(MionZalacznikPubPeer::ZALACZNIK_KOLEJNOSC);
        $this->zalaczniki = MionZalacznikPubPeer::doSelectJoinZalacznikPub($c);

        Functions::setMetaTitle($this->getResponse(), $this->mion->getTemat());
        Functions::setMetaDescription($this->getResponse(), $this->mion->getZajawka());
    }

    public function executeSzukaj(sfWebRequest $request)
    {
        $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/mion/';

        if($request->hasParameter('search'))
        {
            $values = $request->getParameter('search');
            $this->getUser()->setAttribute('srch_mion', $values);
        }
        else
        {
            $values = $this->getUser()->getAttribute('srch_mion');
        }

        // z wyszukiwarki na srodku strony moze przyjsc search[] bez pola 'query'
        if(empty($values['query']))
            $values['query'] = '';
        $query = $values['query'];
        $this->getUser()->setAttribute('global_query', (empty($query) ? null : $query), 'search');
        $this->keyword = $query;

        $c = new CriteriaExt();
        if(!empty($query))
        {
            $this->parser = '';
            $matches = Functions::getLuceneMatches('mion', $query, $this->parser);

            if(!empty($matches))
            {
                $c->add(MionPubPeer::ID, array_keys($matches), Criteria::IN);
                $c->addOrderByField(MionPubPeer::ID, array_keys($matches));

                $this->scores = $matches;
            }
            else
            {
                $c1 = $c->getNewCriterion(MionPubPeer::TEMAT, "%".$query."%", Criteria::LIKE);
                $c2 = $c->getNewCriterion(MionPubPeer::ZAJAWKA, "%".$query."%", Criteria::LIKE);
                $c3 = $c->getNewCriterion(MionPubPeer::TRESC, "%".$query."%", Criteria::LIKE);
                $c2->addOr($c3);
                $c1->addOr($c2);
                $c->add($c1);
            }
        }
        //data
        if(isset($values['data_od']) && $values['data_od'] != "" && isset($values['data_do']) && $values['data_do'] != "")
        {
            $c4 = $c->getNewCriterion(MionPubPeer::CREATED_AT, $values['data_od'].' 00:00:00', Criteria::GREATER_EQUAL);
            $c5 = $c->getNewCriterion(MionPubPeer::CREATED_AT, $values['data_do'].' 23:59:59', Criteria::LESS_EQUAL);
            $c4->addAnd($c5);
            $c->add($c4);
        }
        elseif(isset($values['data_od']) && $values['data_od'] != "")
        {
            $c6 = $c->getNewCriterion(MionPubPeer::CREATED_AT, $values['data_od'].' 00:00:00', Criteria::GREATER_EQUAL);
            $c->add($c6);
        }
        elseif(isset($values['data_do']) && $values['data_do'] != "")
        {
            $c7 = $c->getNewCriterion(MionPubPeer::CREATED_AT, $values['data_do'].' 23:59:59', Criteria::LESS_EQUAL);
            $c->add($c7);
        }

        $wiek = isset($values['wiek']) ? $values['wiek'] : null;
        $stopien = isset($values['stopien']) ? $values['stopien'] : null;
        $przyczyna = isset($values['przyczyna']) ? $values['przyczyna'] : null;

        switch ($wiek)
        {
            case '1': $wiek_col = MionPubPeer::WIEK1;
                break;
            case '2': $wiek_col = MionPubPeer::WIEK2;
                break;
            case '3': $wiek_col = MionPubPeer::WIEK3;
                break;
            case '4': $wiek_col = MionPubPeer::WIEK4;
                break;
            case '5': $wiek_col = MionPubPeer::WIEK5;
                break;
            default: $wiek_col = false;
        }
        if($wiek_col)
        {
            $c->add($wiek_col, 1);
        }

        switch ($stopien)
        {
            case '1': $stopien_col = MionPubPeer::NP_ZNACZNY;
                break;
            case '2': $stopien_col = MionPubPeer::NP_UMIARKOWANY;
                break;
            case '3': $stopien_col = MionPubPeer::NP_LEKKI;
                break;
            default: $stopien_col = false;
        }
        if($stopien_col && $wiek != '1')
        {
            $c->add($stopien_col, 1);
        }

        switch ($przyczyna)
        {
            case '1': $przyczyna_col = MionPubPeer::PRZYCZYNA_WZROK;
                break;
            case '2': $przyczyna_col = MionPubPeer::PRZYCZYNA_MOWA;
                break;
            case '3': $przyczyna_col = MionPubPeer::PRZYCZYNA_RUCH;
                break;
            case '4': $przyczyna_col = MionPubPeer::PRZYCZYNA_INNE;
                break;
            default: $przyczyna_col = false;
        }
        if($przyczyna_col)
        {
            $c->add($przyczyna_col, 1);
        }

        $c->addJoin(MionKategoriaMapPubPeer::MION_ID, MionPubPeer::ID);
        $c->addAscendingOrderByColumn(MionPubPeer::TEMAT);
        $c->addGroupByColumn(MionKategoriaMapPubPeer::MION_ID);
        $c->setDistinct();
        $pager = new sfPropelPager('MionKategoriaMapPub', sfConfig::get('app_pages'));
        $pager->setCriteria($c);
        $pager->setPage($this->getRequestParameter('strona', 1));
        $pager->setPeerCountMethod('doCountDistinctDocs');
        $pager->init();
        $this->pager = $pager;

        //aktualizacja rejestru fraz
        if($request->isMethod('post') && !empty($values['query']))
        {
            if($pager->getNbResults() == 0)
            {
                RejestrFraz::dodajFraze($values['query']);
            }
            else
            {
                RejestrFraz::dodajFraze($values['query'], true);
            }
        }
    }

    public function executeGetSearchForm(sfWebRequest $request)
    {
        $this->disp = $request->getCookie('show_search') ? 'block' : 'none';
        $this->hash_id = $request->getParameter('hash_id');
        $this->form = new MionSzukajAdvForm(array(), array('hash_id' => $this->hash_id));

        if($this->getUser()->hasAttribute('srch_mion'))
        {
            $srch = $this->getUser()->getAttribute('srch_mion');
            if(empty($srch['query']))
            {
                $srch['query'] = $this->getUser()->getAttribute('global_query', $this->form->getDefault('query'), 'search');
            }
            //pZ: w sesji mam juz wartosci po doClean() - ponadto bind() ustawial CheckBoxy jesli wartosc byla ustawiona na null
            $this->form->setDefaults($srch);
        }
    }

    public function executePodglad(sfWebRequest $request)
    {
        $perm_modul = $this->getUser()->checkPermission('mion', 'edit');
        if(!$perm_modul)
        {

            return;
        }

        $this->preview_mode = true;
        $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/mion/';

        $id = $request->getParameter('id');
        $this->mion = MionPeer::retrieveByPk($id);
        $this->forward404Unless($this->mion);

        $c = new Criteria();
        $c->add(MionZalacznikPeer::MION_ID, $id);
        $c->addAscendingOrderByColumn(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC);
        $this->zalaczniki = MionZalacznikPeer::doSelectJoinZalacznik($c);

        $this->setTemplate('pokaz');
    }

    public function executePodgladZajawki(sfWebRequest $request)
    {
        $perm_modul = $this->getUser()->checkPermission('mion', 'edit');
        if(!$perm_modul)
        {
            $this->setTemplate('podglad');

            return;
        }

        $this->preview_mode = true;
        $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/mion/';

        $id = $request->getParameter('id');
        $this->mion = MionPeer::retrieveByPk($id);
        $this->forward404Unless($this->mion);
    }

}