<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * Mion filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseMionFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'identyfikator'           => new sfWidgetFormFilterInput(),
      'created_at'              => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'updated_at'              => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'temat'                   => new sfWidgetFormFilterInput(),
      'zajawka'                 => new sfWidgetFormFilterInput(),
      'grafika'                 => new sfWidgetFormFilterInput(),
      'opis_grafiki'            => new sfWidgetFormFilterInput(),
      'prefix_grafiki_zajawki'  => new sfWidgetFormFilterInput(),
      'tresc'                   => new sfWidgetFormFilterInput(),
      'stan_prawny'             => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'wiek1'                   => new sfWidgetFormFilterInput(),
      'wiek2'                   => new sfWidgetFormFilterInput(),
      'wiek3'                   => new sfWidgetFormFilterInput(),
      'wiek4'                   => new sfWidgetFormFilterInput(),
      'wiek5'                   => new sfWidgetFormFilterInput(),
      'np_lekki'                => new sfWidgetFormFilterInput(),
      'np_umiarkowany'          => new sfWidgetFormFilterInput(),
      'np_znaczny'              => new sfWidgetFormFilterInput(),
      'przyczyna_wzrok'         => new sfWidgetFormFilterInput(),
      'przyczyna_mowa'          => new sfWidgetFormFilterInput(),
      'przyczyna_ruch'          => new sfWidgetFormFilterInput(),
      'przyczyna_inne'          => new sfWidgetFormFilterInput(),
      'zatwierdzona'            => new sfWidgetFormFilterInput(),
      'uzytkownik_id'           => new sfWidgetFormPropelChoice(array('model' => 'sfGuardUser', 'add_empty' => true)),
      'komentarz'               => new sfWidgetFormFilterInput(),
      'mion_kategoria_map_list' => new sfWidgetFormPropelChoice(array('model' => 'MionKategoria', 'add_empty' => true)),
      'mion_zalacznik_list'     => new sfWidgetFormPropelChoice(array('model' => 'Zalacznik', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'identyfikator'           => new sfValidatorPass(array('required' => false)),
      'created_at'              => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'updated_at'              => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'temat'                   => new sfValidatorPass(array('required' => false)),
      'zajawka'                 => new sfValidatorPass(array('required' => false)),
      'grafika'                 => new sfValidatorPass(array('required' => false)),
      'opis_grafiki'            => new sfValidatorPass(array('required' => false)),
      'prefix_grafiki_zajawki'  => new sfValidatorPass(array('required' => false)),
      'tresc'                   => new sfValidatorPass(array('required' => false)),
      'stan_prawny'             => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'wiek1'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'wiek2'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'wiek3'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'wiek4'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'wiek5'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'np_lekki'                => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'np_umiarkowany'          => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'np_znaczny'              => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'przyczyna_wzrok'         => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'przyczyna_mowa'          => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'przyczyna_ruch'          => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'przyczyna_inne'          => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'zatwierdzona'            => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'uzytkownik_id'           => new sfValidatorPropelChoice(array('required' => false, 'model' => 'sfGuardUser', 'column' => 'id')),
      'komentarz'               => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'mion_kategoria_map_list' => new sfValidatorPropelChoice(array('model' => 'MionKategoria', 'required' => false)),
      'mion_zalacznik_list'     => new sfValidatorPropelChoice(array('model' => 'Zalacznik', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('mion_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function addMionKategoriaMapListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(MionKategoriaMapPeer::MION_ID, MionPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(MionKategoriaMapPeer::KATEGORIA_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(MionKategoriaMapPeer::KATEGORIA_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function addMionZalacznikListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(MionZalacznikPeer::MION_ID, MionPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(MionZalacznikPeer::ZALACZNIK_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(MionZalacznikPeer::ZALACZNIK_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function getModelName()
  {
    return 'Mion';
  }

  public function getFields()
  {
    return array(
      'id'                      => 'Number',
      'identyfikator'           => 'Text',
      'created_at'              => 'Date',
      'updated_at'              => 'Date',
      'temat'                   => 'Text',
      'zajawka'                 => 'Text',
      'grafika'                 => 'Text',
      'opis_grafiki'            => 'Text',
      'prefix_grafiki_zajawki'  => 'Text',
      'tresc'                   => 'Text',
      'stan_prawny'             => 'Date',
      'wiek1'                   => 'Number',
      'wiek2'                   => 'Number',
      'wiek3'                   => 'Number',
      'wiek4'                   => 'Number',
      'wiek5'                   => 'Number',
      'np_lekki'                => 'Number',
      'np_umiarkowany'          => 'Number',
      'np_znaczny'              => 'Number',
      'przyczyna_wzrok'         => 'Number',
      'przyczyna_mowa'          => 'Number',
      'przyczyna_ruch'          => 'Number',
      'przyczyna_inne'          => 'Number',
      'zatwierdzona'            => 'Number',
      'uzytkownik_id'           => 'ForeignKey',
      'komentarz'               => 'Number',
      'mion_kategoria_map_list' => 'ManyKey',
      'mion_zalacznik_list'     => 'ManyKey',
    );
  }
}
