<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * MionKategoria filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseMionKategoriaFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'created_at'                  => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'updated_at'                  => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'nazwa'                       => new sfWidgetFormFilterInput(),
      'kolejnosc'                   => new sfWidgetFormFilterInput(),
      'mion_kategoria_map_list'     => new sfWidgetFormPropelChoice(array('model' => 'Mion', 'add_empty' => true)),
      'mion_kategoria_map_pub_list' => new sfWidgetFormPropelChoice(array('model' => 'MionPub', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'created_at'                  => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'updated_at'                  => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'nazwa'                       => new sfValidatorPass(array('required' => false)),
      'kolejnosc'                   => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'mion_kategoria_map_list'     => new sfValidatorPropelChoice(array('model' => 'Mion', 'required' => false)),
      'mion_kategoria_map_pub_list' => new sfValidatorPropelChoice(array('model' => 'MionPub', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('mion_kategoria_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function addMionKategoriaMapListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(MionKategoriaMapPeer::KATEGORIA_ID, MionKategoriaPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(MionKategoriaMapPeer::MION_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(MionKategoriaMapPeer::MION_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function addMionKategoriaMapPubListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(MionKategoriaMapPubPeer::KATEGORIA_ID, MionKategoriaPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(MionKategoriaMapPubPeer::MION_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(MionKategoriaMapPubPeer::MION_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function getModelName()
  {
    return 'MionKategoria';
  }

  public function getFields()
  {
    return array(
      'id'                          => 'Number',
      'created_at'                  => 'Date',
      'updated_at'                  => 'Date',
      'nazwa'                       => 'Text',
      'kolejnosc'                   => 'Number',
      'mion_kategoria_map_list'     => 'ManyKey',
      'mion_kategoria_map_pub_list' => 'ManyKey',
    );
  }
}
