<?php

/**
 * Mion form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class MionForm extends BaseMionForm {
    public function configure() {
        $url = sfContext::getInstance()->getRequest()->getRelativeUrlRoot();

        sfContext::getInstance()->getConfiguration()->loadHelpers(array('I18N'));
        
        unset($this['ion_zalacznik_list']);
        unset($this['mion_kategoria_map_list']);

        $this->setWidgets(array(
            'id'                      => new sfWidgetFormInputHidden(),
            'identyfikator'           => new sfWidgetFormInput(),
            'created_at'              => new sfWidgetFormInputHidden(),
            'updated_at'              => new sfWidgetFormInputHidden(),
            'temat'                   => new sfWidgetFormInput(array(),array('class' => 'required input')),
            'zajawka'                 => new sfWidgetFormTextarea(),
            'grafika'      => new sfWidgetFormInputFileEditable(array(
                'file_src'     => sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/mion/doc_'. $this->getObject()->getId().'/zajawki/thumb_'.$this->getObject()->getGrafika(),
                'is_image'     => true,
                'edit_mode'    => !$this->isNew() && $this->getObject()->getGrafika()!='',
                'delete_label' => __('usuń zdjęcie'),
                'with_delete'  => true,
                'template'     => '%file%<br />%input%<br />%delete% %delete_label%'
                )),
            'tresc'       => new sfWidgetFormTextareaTinyMCEUser(
            array('width' => "600",'height' => '400', 'can_be_adv' => true),
            array(
                'class'   =>  'tiny_mce'
            )),
            'stan_prawny'             => new sfWidgetFormInputDateRich(),
            'wiek1'                   => new sfWidgetFormInputCheckbox(),
            'wiek2'                   => new sfWidgetFormInputCheckbox(),
            'wiek3'                   => new sfWidgetFormInputCheckbox(),
            'wiek4'                   => new sfWidgetFormInputCheckbox(),
            'wiek5'                   => new sfWidgetFormInputCheckbox(),
            'np_lekki'                => new sfWidgetFormInputCheckbox(),
            'np_umiarkowany'          => new sfWidgetFormInputCheckbox(),
            'np_znaczny'              => new sfWidgetFormInputCheckbox(),
            'przyczyna_wzrok'         => new sfWidgetFormInputCheckbox(),
            'przyczyna_mowa'          => new sfWidgetFormInputCheckbox(),
            'przyczyna_ruch'          => new sfWidgetFormInputCheckbox(),
            'przyczyna_inne'          => new sfWidgetFormInputCheckbox(),
            'zatwierdzona'            => new sfWidgetFormInputHidden(),
        ));

    if(Comments::showInForms('mion')) {
            $this->widgetSchema['komentarz'] = new  sfWidgetFormSelect(array('choices' => array(0=>'Nie',1=>'Tak'), 'default' => 1));
        }else {
            $this->widgetSchema['komentarz'] = new sfWidgetFormInputHidden();
        }

        $this->setValidators(array(
            'id'                      => new sfValidatorPropelChoice(array('model' => 'Mion', 'column' => 'id', 'required' => false)),
            'identyfikator'           => new sfValidatorString(array('max_length' => 11, 'required' => false)),
            'created_at'              => new sfValidatorDateTime(array('required' => false)),
            'updated_at'              => new sfValidatorDateTime(array('required' => false)),
            'temat'                   => new sfValidatorString(array('max_length' => 255)),
            'zajawka'                 => new sfValidatorString(array('required' => false)),
            'grafika'                 => new ciValidatorFile(array(
                'required' => false,
                'path' => sfConfig::get('sf_upload_dir').'/mion/doc_'.$this->getObject()->getId().'/zajawki',
                'mime_types' => 'web_images',
                'max_size' => 5242880
                ), array(
                    'max_size' => 'Maksymalna dozwolona wielkość obrazka to 5MB!',
                    'mime_types' => 'Nieprawidłowy typ pliku!'
            )),
            'tresc'                   => new sfValidatorString(),
            'stan_prawny'             => new sfValidatorDate(array('required' => false)),
            'wiek1'                   => new sfValidatorString(array('required' => false)),
            'wiek2'                   => new sfValidatorString(array('required' => false)),
            'wiek3'                   => new sfValidatorString(array('required' => false)),
            'wiek4'                   => new sfValidatorString(array('required' => false)),
            'wiek5'                   => new sfValidatorString(array('required' => false)),
            'np_lekki'                => new sfValidatorString(array('required' => false)),
            'np_umiarkowany'          => new sfValidatorString(array('required' => false)),
            'np_znaczny'              => new sfValidatorString(array('required' => false)),
            'przyczyna_wzrok'         => new sfValidatorString(array('required' => false)),
            'przyczyna_mowa'          => new sfValidatorString(array('required' => false)),
            'przyczyna_ruch'          => new sfValidatorString(array('required' => false)),
            'przyczyna_inne'          => new sfValidatorString(array('required' => false)),
            'zatwierdzona'            => new sfValidatorChoice(array('choices' => array('0', '1'))),
            'komentarz' => new sfValidatorChoice(array('choices' => array(0,1), 'required' => false)),
        ));
        $this->setValidator('grafika_delete', new sfValidatorString(array('required' => false)));


        $c_kat = new Criteria();
        $c_kat->addAscendingOrderByColumn(MionKategoriaPeer::NAZWA);
        $this->widgetSchema['mion_kategoria_map_list'] =  new sfWidgetFormPropelChoiceMany(array('model' => 'MionKategoria', 'criteria'=> $c_kat, 'renderer_class' => 'sfWidgetFormSelectDoubleList'), array('template' => '%label_associated%<br/>%associated%<br/>%associate% %unassociate%<br/>%unassociated%'));

        $this->widgetSchema->setLabels(array(
            'wiek1' => 'Wiek: 0 - 15 lat',
            'wiek2' => 'Wiek: 16 - 17 lat',
            'wiek3' => 'Wiek: 18 - 23 lat',
            'wiek4' => 'Wiek: 24 - 25 lat',
            'wiek5' => 'Wiek: powyżej 25 lat',
            'np_lekki' => 'Stopień niepełnosprawności: lekki',
            'np_umiarkowany' => 'Stopień niepełnosprawności: umiarkowany',
            'np_znaczny' => 'Stopień niepełnosprawności: znaczny',
            'przyczyna_wzrok' => 'Przyczyna niepełnosprawności: narząd wzroku',
            'przyczyna_mowa' => 'Przyczyna niepełnosprawności: narząd słuchu lub mowy',
            'przyczyna_ruch' => 'Przyczyna niepełnosprawności: narząd ruchu',
            'przyczyna_inne' => 'Przyczyna niepełnosprawności: inne',
            'zatwierdzona' => 'Do publikacji',

        ));

        $this->widgetSchema->setHelps(array(
            'identyfikator'           => 'Podaj numer / identyfikator dokumentu',
            'temat'                   => 'Podaj tytuł / temat dokumentu',
            'zajawka'                 => 'Skrócony opis dokumentu',
            'grafika'                 => 'Maksymalna wielkość pliku 5MB',
            'stan_prawny'             => 'Stan prawny dokumentu na dzień',
            'komentarz'               => 'Określ czy będzie możliwosć dodawania komentarzy do dokumentu',
            'mion_kategoria_map_list' => 'Wybierz kategorie, do których należy dokument',

        ));

        $this->widgetSchema->setNameFormat('mion[%s]');

        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }
}
