<?php

/**
 * Mion form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseMionForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                      => new sfWidgetFormInputHidden(),
      'identyfikator'           => new sfWidgetFormInput(),
      'created_at'              => new sfWidgetFormDateTime(),
      'updated_at'              => new sfWidgetFormDateTime(),
      'temat'                   => new sfWidgetFormInput(),
      'zajawka'                 => new sfWidgetFormTextarea(),
      'grafika'                 => new sfWidgetFormInput(),
      'opis_grafiki'            => new sfWidgetFormInput(),
      'prefix_grafiki_zajawki'  => new sfWidgetFormInput(),
      'tresc'                   => new sfWidgetFormTextarea(),
      'stan_prawny'             => new sfWidgetFormDate(),
      'wiek1'                   => new sfWidgetFormInput(),
      'wiek2'                   => new sfWidgetFormInput(),
      'wiek3'                   => new sfWidgetFormInput(),
      'wiek4'                   => new sfWidgetFormInput(),
      'wiek5'                   => new sfWidgetFormInput(),
      'np_lekki'                => new sfWidgetFormInput(),
      'np_umiarkowany'          => new sfWidgetFormInput(),
      'np_znaczny'              => new sfWidgetFormInput(),
      'przyczyna_wzrok'         => new sfWidgetFormInput(),
      'przyczyna_mowa'          => new sfWidgetFormInput(),
      'przyczyna_ruch'          => new sfWidgetFormInput(),
      'przyczyna_inne'          => new sfWidgetFormInput(),
      'zatwierdzona'            => new sfWidgetFormInput(),
      'uzytkownik_id'           => new sfWidgetFormPropelChoice(array('model' => 'sfGuardUser', 'add_empty' => true)),
      'komentarz'               => new sfWidgetFormInput(),
      'mion_kategoria_map_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'MionKategoria')),
      'mion_zalacznik_list'     => new sfWidgetFormPropelChoiceMany(array('model' => 'Zalacznik')),
    ));

    $this->setValidators(array(
      'id'                      => new sfValidatorPropelChoice(array('model' => 'Mion', 'column' => 'id', 'required' => false)),
      'identyfikator'           => new sfValidatorString(array('max_length' => 11, 'required' => false)),
      'created_at'              => new sfValidatorDateTime(array('required' => false)),
      'updated_at'              => new sfValidatorDateTime(array('required' => false)),
      'temat'                   => new sfValidatorString(array('max_length' => 255)),
      'zajawka'                 => new sfValidatorString(array('required' => false)),
      'grafika'                 => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'opis_grafiki'            => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'prefix_grafiki_zajawki'  => new sfValidatorString(array('max_length' => 7, 'required' => false)),
      'tresc'                   => new sfValidatorString(),
      'stan_prawny'             => new sfValidatorDate(array('required' => false)),
      'wiek1'                   => new sfValidatorInteger(array('required' => false)),
      'wiek2'                   => new sfValidatorInteger(array('required' => false)),
      'wiek3'                   => new sfValidatorInteger(array('required' => false)),
      'wiek4'                   => new sfValidatorInteger(array('required' => false)),
      'wiek5'                   => new sfValidatorInteger(array('required' => false)),
      'np_lekki'                => new sfValidatorInteger(array('required' => false)),
      'np_umiarkowany'          => new sfValidatorInteger(array('required' => false)),
      'np_znaczny'              => new sfValidatorInteger(array('required' => false)),
      'przyczyna_wzrok'         => new sfValidatorInteger(array('required' => false)),
      'przyczyna_mowa'          => new sfValidatorInteger(array('required' => false)),
      'przyczyna_ruch'          => new sfValidatorInteger(array('required' => false)),
      'przyczyna_inne'          => new sfValidatorInteger(array('required' => false)),
      'zatwierdzona'            => new sfValidatorInteger(array('required' => false)),
      'uzytkownik_id'           => new sfValidatorPropelChoice(array('model' => 'sfGuardUser', 'column' => 'id', 'required' => false)),
      'komentarz'               => new sfValidatorInteger(array('required' => false)),
      'mion_kategoria_map_list' => new sfValidatorPropelChoiceMany(array('model' => 'MionKategoria', 'required' => false)),
      'mion_zalacznik_list'     => new sfValidatorPropelChoiceMany(array('model' => 'Zalacznik', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('mion[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Mion';
  }


  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['mion_kategoria_map_list']))
    {
      $values = array();
      foreach ($this->object->getMionKategoriaMaps() as $obj)
      {
        $values[] = $obj->getKategoriaId();
      }

      $this->setDefault('mion_kategoria_map_list', $values);
    }

    if (isset($this->widgetSchema['mion_zalacznik_list']))
    {
      $values = array();
      foreach ($this->object->getMionZalaczniks() as $obj)
      {
        $values[] = $obj->getZalacznikId();
      }

      $this->setDefault('mion_zalacznik_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveMionKategoriaMapList($con);
    $this->saveMionZalacznikList($con);
  }

  public function saveMionKategoriaMapList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['mion_kategoria_map_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(MionKategoriaMapPeer::MION_ID, $this->object->getPrimaryKey());
    MionKategoriaMapPeer::doDelete($c, $con);

    $values = $this->getValue('mion_kategoria_map_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new MionKategoriaMap();
        $obj->setMionId($this->object->getPrimaryKey());
        $obj->setKategoriaId($value);
        $obj->save();
      }
    }
  }

  public function saveMionZalacznikList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['mion_zalacznik_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(MionZalacznikPeer::MION_ID, $this->object->getPrimaryKey());
    MionZalacznikPeer::doDelete($c, $con);

    $values = $this->getValue('mion_zalacznik_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new MionZalacznik();
        $obj->setMionId($this->object->getPrimaryKey());
        $obj->setZalacznikId($value);
        $obj->save();
      }
    }
  }

}
