<?php

/**
 * MionKategoria form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseMionKategoriaForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                          => new sfWidgetFormInputHidden(),
      'created_at'                  => new sfWidgetFormDateTime(),
      'updated_at'                  => new sfWidgetFormDateTime(),
      'nazwa'                       => new sfWidgetFormInput(),
      'kolejnosc'                   => new sfWidgetFormInput(),
      'mion_kategoria_map_list'     => new sfWidgetFormPropelChoiceMany(array('model' => 'Mion')),
      'mion_kategoria_map_pub_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'MionPub')),
    ));

    $this->setValidators(array(
      'id'                          => new sfValidatorPropelChoice(array('model' => 'MionKategoria', 'column' => 'id', 'required' => false)),
      'created_at'                  => new sfValidatorDateTime(array('required' => false)),
      'updated_at'                  => new sfValidatorDateTime(array('required' => false)),
      'nazwa'                       => new sfValidatorString(array('max_length' => 150)),
      'kolejnosc'                   => new sfValidatorInteger(array('required' => false)),
      'mion_kategoria_map_list'     => new sfValidatorPropelChoiceMany(array('model' => 'Mion', 'required' => false)),
      'mion_kategoria_map_pub_list' => new sfValidatorPropelChoiceMany(array('model' => 'MionPub', 'required' => false)),
    ));

    $this->validatorSchema->setPostValidator(
      new sfValidatorPropelUnique(array('model' => 'MionKategoria', 'column' => array('nazwa')))
    );

    $this->widgetSchema->setNameFormat('mion_kategoria[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'MionKategoria';
  }


  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['mion_kategoria_map_list']))
    {
      $values = array();
      foreach ($this->object->getMionKategoriaMaps() as $obj)
      {
        $values[] = $obj->getMionId();
      }

      $this->setDefault('mion_kategoria_map_list', $values);
    }

    if (isset($this->widgetSchema['mion_kategoria_map_pub_list']))
    {
      $values = array();
      foreach ($this->object->getMionKategoriaMapPubs() as $obj)
      {
        $values[] = $obj->getMionId();
      }

      $this->setDefault('mion_kategoria_map_pub_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveMionKategoriaMapList($con);
    $this->saveMionKategoriaMapPubList($con);
  }

  public function saveMionKategoriaMapList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['mion_kategoria_map_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->object->getPrimaryKey());
    MionKategoriaMapPeer::doDelete($c, $con);

    $values = $this->getValue('mion_kategoria_map_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new MionKategoriaMap();
        $obj->setKategoriaId($this->object->getPrimaryKey());
        $obj->setMionId($value);
        $obj->save();
      }
    }
  }

  public function saveMionKategoriaMapPubList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['mion_kategoria_map_pub_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->object->getPrimaryKey());
    MionKategoriaMapPubPeer::doDelete($c, $con);

    $values = $this->getValue('mion_kategoria_map_pub_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new MionKategoriaMapPub();
        $obj->setKategoriaId($this->object->getPrimaryKey());
        $obj->setMionId($value);
        $obj->save();
      }
    }
  }

}
