<?php

class Mion extends BaseMion {

    private $is_published;
    
    public function kopiujDoPub() {
        $func = new Functions();

        $pub = MionPubPeer::retrieveByPK($this->getId());
        if(!$pub) {
            $pub = new MionPub();
        }
        $temp = $this->toArray(BasePeer::TYPE_FIELDNAME);
        $pub->fromArray($temp,BasePeer::TYPE_FIELDNAME);
        $pub->save();

        $this->setZatwierdzona(1);
        $this->save();

        $a_temp_path = sfConfig::get('sf_upload_dir').'/mion/doc_'.$this->getId();
        $a_pub_path = sfConfig::get('sf_upload_dir').'/mion/doc_'.$this->getId().'_pub';
        
        if(is_dir($a_pub_path)){
            Functions::rrmdir($a_pub_path);
        }

        $this->kopiujZalacznikiDoPub('/mion/doc_'.$this->getId().'_pub/zalaczniki');

        //Kopiowanie katalogow na dysku
        if(is_dir($a_temp_path))Functions::full_copy($a_temp_path, $a_pub_path);

        //kategorie, najpierw usun poprzednie
        $c = new Criteria();
        $c->add(MionKategoriaMapPubPeer::MION_ID, $this->getId());
        MionKategoriaMapPubPeer::doDelete($c);
        //i potem skopiuj nowe
        $c = new Criteria();
        $c->add(MionKategoriaMapPeer::MION_ID, $this->getId());
        $kategorie = MionKategoriaMapPeer::doSelect($c);
        foreach ($kategorie as $kat) {
            $k = new MionKategoriaMapPub();
            $k->setMionId($kat->getMionId());
            $k->setKategoriaId($kat->getKategoriaId());
            $k->save();
        }


    }

    protected  function kopiujZalacznikiDoPub($z_pub_path = null) {
        $z_temp = $this->getAllZalacznik();
        $z_pub  = $this->getAllZalacznikPub();

        //usun wpisy dotyczace zalacznikow pulikowanych
        foreach ($z_pub as $zp) {
            $zp->getZalacznikPub()->delete();
        }
        //Dodaj te zwiazane z publikowanymi
        if($z_temp) {
            foreach ($z_temp as $zt) {
                $z = new ZalacznikPub();
                $z->setId($zt->getZalacznik()->getId());
                $z->setNazwaPliku($zt->getZalacznik()->getNazwaPliku());
                $z->setNazwa($zt->getZalacznik()->getNazwa());
                $z->setRozmiarPliku($zt->getZalacznik()->getRozmiarPliku());
                $z->setSciezka($z_pub_path);
                $z->setOpis($zt->getZalacznik()->getOpis());
                $z->setPobran($zt->getZalacznik()->getPobran());
                $z->save();

                $mion_zp = new MionZalacznikPub();
                $mion_zp->setMionId($zt->getMionId());
                $mion_zp->setZalacznikId($z->getId());
                $mion_zp->setZalacznikKolejnosc($zt->getZalacznikKolejnosc());
                $mion_zp->save();
            }
        }
    }

    public function getAllZalacznik() {
        $c = new Criteria();
        $c->add(MionZalacznikPeer::MION_ID, $this->getId());

        return MionZalacznikPeer::doSelectJoinZalacznik($c);
    }

    public function getAllZalacznikPub() {
        $c = new Criteria();
        $c->add(MionZalacznikPubPeer::MION_ID, $this->getId());
        return MionZalacznikPubPeer::doSelectJoinZalacznikPub($c);
    }

    public function usunZPub() {

        sfContext::getInstance()->getConfiguration()->loadHelpers(array('Funkcje'));
        $pub = MionPubPeer::retrieveByPK($this->getId());
        $pub_path = sfConfig::get('sf_upload_dir').'/mion/doc_'.$pub->getId().'_pub';
        if(is_dir($pub_path)) {
            recursive_remove_directory($pub_path);
        }
        //i usun zalaczniki pub z tabeli zalaczniki

        $zalaczniki = $this->getAllZalacznikPub();

        //usun wpisy dotyczace zalacznikow publikowanych
        foreach ($zalaczniki as $zp) {
            $zp->getZalacznik()->delete();
        }

        $pub->delete();
        //usun info z tabeli mapujacej kategorie
        $c = new Criteria();
        $c->add(MionKategoriaMapPubPeer::MION_ID, $this->getId());
        MionKategoriaMapPubPeer::doDelete($c);

        $this->setZatwierdzona(0);
        $this->save();
    }

    public function getNext()//do podgladu
    {
        if($this->getCreatedAt()) {
            $c = new Criteria();
            $c->add(MionPubPeer::CREATED_AT,$this->getCreatedAt(), Criteria::GREATER_THAN);
            $c->addAscendingOrderByColumn(MionPubPeer::CREATED_AT);
            return MionPubPeer::doSelectOne($c);
        }
        else return null;
    }

    public function getPrev()//do podgladu
    {
        if($this->getCreatedAt()) {
            $c = new Criteria();
            $c->add(MionPubPeer::CREATED_AT,$this->getCreatedAt(), Criteria::LESS_THAN);
            $c->addDescendingOrderByColumn(MionPubPeer::CREATED_AT);
            return MionPubPeer::doSelectOne($c);
        }
        else return null;
    }

    public function jestOpublikowany() {
        if($this->is_published === null) {
            $crit = new Criteria();
            $crit->add(MionPubPeer::ID,$this->getId());
            $pubs = MionPubPeer::doCount($crit);
            $this->is_published = $pubs?true:false;
        }

        return $this->is_published;
    }

    /**
     * Determine if user can edit document
     *
     * @param   myUser $user Instance of myUser object
     * @return  bool True if user can edit document, false otherwise
     */
    public function canBeEditedBy(myUser $user) {
        $permGlobal = $user->checkPermission('mion_global','edit') == 1 ? true : false;
        $isOwner = ($this->getUzytkownikId() == $user->getId());

        return $permGlobal || $isOwner;
    }

    /**
     * Determine if user can publish/unpublish document
     *
     * @param   myUser $user Instance of myUser object
     * @return  bool True if user can publish/unpublish document, false otherwise
     */
    public function canBePublishedBy(myUser $user) {
        $permGlobal = $user->checkPermission('mion_global','publish') == 1 ? true : false;
        $permUser = $user->checkPermission('mion_user','publish') == 1 ? true : false;
        $isOwner = ($this->getUzytkownikId() == $user->getId());

        return $permGlobal || ($isOwner && $permUser);
    }

    /**
     * Determine if user can delete document
     *
     * @param   myUser $user Instance of myUser object
     * @return  bool True if user can delete document, false otherwise
     */
    public function canBeDeletedBy(myUser $user) {
        $isOwner = ($this->getUzytkownikId() == $user->getId());
        if($this->jestOpublikowany()) {
            $canDelete = $this->canBePublishedBy($user);
        }
        else {
            $canDelete = $this->canBeEditedBy($user);
        }

        return $canDelete;
    }

        public function getParsedTresc() {
        return Functions::parseCiCode(parent::getTresc());
    }
}
