<?php



class MionMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.MionMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(MionPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(MionPeer::TABLE_NAME);
		$tMap->setPhpName('Mion');
		$tMap->setClassname('Mion');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addColumn('IDENTYFIKATOR', 'Identyfikator', 'VARCHAR', false, 11);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('TEMAT', 'Temat', 'VARCHAR', true, 255);

		$tMap->addColumn('ZAJAWKA', 'Zajawka', 'LONGVARCHAR', false, null);

		$tMap->addColumn('GRAFIKA', 'Grafika', 'VARCHAR', false, 255);

		$tMap->addColumn('OPIS_GRAFIKI', 'OpisGrafiki', 'VARCHAR', false, 255);

		$tMap->addColumn('PREFIX_GRAFIKI_ZAJAWKI', 'PrefixGrafikiZajawki', 'VARCHAR', false, 7);

		$tMap->addColumn('TRESC', 'Tresc', 'LONGVARCHAR', true, null);

		$tMap->addColumn('STAN_PRAWNY', 'StanPrawny', 'DATE', false, null);

		$tMap->addColumn('WIEK1', 'Wiek1', 'TINYINT', false, 1);

		$tMap->addColumn('WIEK2', 'Wiek2', 'TINYINT', false, 1);

		$tMap->addColumn('WIEK3', 'Wiek3', 'TINYINT', false, 1);

		$tMap->addColumn('WIEK4', 'Wiek4', 'TINYINT', false, 1);

		$tMap->addColumn('WIEK5', 'Wiek5', 'TINYINT', false, 1);

		$tMap->addColumn('NP_LEKKI', 'NpLekki', 'TINYINT', false, 1);

		$tMap->addColumn('NP_UMIARKOWANY', 'NpUmiarkowany', 'TINYINT', false, 1);

		$tMap->addColumn('NP_ZNACZNY', 'NpZnaczny', 'TINYINT', false, 1);

		$tMap->addColumn('PRZYCZYNA_WZROK', 'PrzyczynaWzrok', 'TINYINT', false, 1);

		$tMap->addColumn('PRZYCZYNA_MOWA', 'PrzyczynaMowa', 'TINYINT', false, 1);

		$tMap->addColumn('PRZYCZYNA_RUCH', 'PrzyczynaRuch', 'TINYINT', false, 1);

		$tMap->addColumn('PRZYCZYNA_INNE', 'PrzyczynaInne', 'TINYINT', false, 1);

		$tMap->addColumn('ZATWIERDZONA', 'Zatwierdzona', 'TINYINT', false, 1);

		$tMap->addForeignKey('UZYTKOWNIK_ID', 'UzytkownikId', 'INTEGER', 'sf_guard_user', 'ID', false, 11);

		$tMap->addColumn('KOMENTARZ', 'Komentarz', 'TINYINT', false, 1);

	} 
} 