<?php


abstract class BaseMionKategoria extends BaseObject  implements Persistent {


  const PEER = 'MionKategoriaPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $nazwa;

	
	protected $kolejnosc;

	
	protected $collMionKategoriaMaps;

	
	private $lastMionKategoriaMapCriteria = null;

	
	protected $collMionKategoriaMapPubs;

	
	private $lastMionKategoriaMapPubCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->kolejnosc = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getNazwa()
	{
		return $this->nazwa;
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = MionKategoriaPeer::ID;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = MionKategoriaPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = MionKategoriaPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setNazwa($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa !== $v) {
			$this->nazwa = $v;
			$this->modifiedColumns[] = MionKategoriaPeer::NAZWA;
		}

		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = MionKategoriaPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(MionKategoriaPeer::KOLEJNOSC))) {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->created_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->updated_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->nazwa = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->kolejnosc = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating MionKategoria object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = MionKategoriaPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->collMionKategoriaMaps = null;
			$this->lastMionKategoriaMapCriteria = null;

			$this->collMionKategoriaMapPubs = null;
			$this->lastMionKategoriaMapPubCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			MionKategoriaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(MionKategoriaPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(MionKategoriaPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			MionKategoriaPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = MionKategoriaPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MionKategoriaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += MionKategoriaPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collMionKategoriaMaps !== null) {
				foreach ($this->collMionKategoriaMaps as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collMionKategoriaMapPubs !== null) {
				foreach ($this->collMionKategoriaMapPubs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = MionKategoriaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collMionKategoriaMaps !== null) {
					foreach ($this->collMionKategoriaMaps as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collMionKategoriaMapPubs !== null) {
					foreach ($this->collMionKategoriaMapPubs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MionKategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getCreatedAt();
				break;
			case 2:
				return $this->getUpdatedAt();
				break;
			case 3:
				return $this->getNazwa();
				break;
			case 4:
				return $this->getKolejnosc();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = MionKategoriaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getCreatedAt(),
			$keys[2] => $this->getUpdatedAt(),
			$keys[3] => $this->getNazwa(),
			$keys[4] => $this->getKolejnosc(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MionKategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setCreatedAt($value);
				break;
			case 2:
				$this->setUpdatedAt($value);
				break;
			case 3:
				$this->setNazwa($value);
				break;
			case 4:
				$this->setKolejnosc($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = MionKategoriaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCreatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUpdatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNazwa($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setKolejnosc($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);

		if ($this->isColumnModified(MionKategoriaPeer::ID)) $criteria->add(MionKategoriaPeer::ID, $this->id);
		if ($this->isColumnModified(MionKategoriaPeer::CREATED_AT)) $criteria->add(MionKategoriaPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(MionKategoriaPeer::UPDATED_AT)) $criteria->add(MionKategoriaPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(MionKategoriaPeer::NAZWA)) $criteria->add(MionKategoriaPeer::NAZWA, $this->nazwa);
		if ($this->isColumnModified(MionKategoriaPeer::KOLEJNOSC)) $criteria->add(MionKategoriaPeer::KOLEJNOSC, $this->kolejnosc);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);

		$criteria->add(MionKategoriaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setNazwa($this->nazwa);

		$copyObj->setKolejnosc($this->kolejnosc);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getMionKategoriaMaps() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addMionKategoriaMap($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getMionKategoriaMapPubs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addMionKategoriaMapPub($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MionKategoriaPeer();
		}
		return self::$peer;
	}

	
	public function clearMionKategoriaMaps()
	{
		$this->collMionKategoriaMaps = null; 	}

	
	public function initMionKategoriaMaps()
	{
		$this->collMionKategoriaMaps = array();
	}

	
	public function getMionKategoriaMaps($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMionKategoriaMaps === null) {
			if ($this->isNew()) {
			   $this->collMionKategoriaMaps = array();
			} else {

				$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->id);

				MionKategoriaMapPeer::addSelectColumns($criteria);
				$this->collMionKategoriaMaps = MionKategoriaMapPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->id);

				MionKategoriaMapPeer::addSelectColumns($criteria);
				if (!isset($this->lastMionKategoriaMapCriteria) || !$this->lastMionKategoriaMapCriteria->equals($criteria)) {
					$this->collMionKategoriaMaps = MionKategoriaMapPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMionKategoriaMapCriteria = $criteria;
		return $this->collMionKategoriaMaps;
	}

	
	public function countMionKategoriaMaps(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collMionKategoriaMaps === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->id);

				$count = MionKategoriaMapPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->id);

				if (!isset($this->lastMionKategoriaMapCriteria) || !$this->lastMionKategoriaMapCriteria->equals($criteria)) {
					$count = MionKategoriaMapPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collMionKategoriaMaps);
				}
			} else {
				$count = count($this->collMionKategoriaMaps);
			}
		}
		return $count;
	}

	
	public function addMionKategoriaMap(MionKategoriaMap $l)
	{
		if ($this->collMionKategoriaMaps === null) {
			$this->initMionKategoriaMaps();
		}
		if (!in_array($l, $this->collMionKategoriaMaps, true)) { 			array_push($this->collMionKategoriaMaps, $l);
			$l->setMionKategoria($this);
		}
	}


	
	public function getMionKategoriaMapsJoinMion($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMionKategoriaMaps === null) {
			if ($this->isNew()) {
				$this->collMionKategoriaMaps = array();
			} else {

				$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->id);

				$this->collMionKategoriaMaps = MionKategoriaMapPeer::doSelectJoinMion($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->id);

			if (!isset($this->lastMionKategoriaMapCriteria) || !$this->lastMionKategoriaMapCriteria->equals($criteria)) {
				$this->collMionKategoriaMaps = MionKategoriaMapPeer::doSelectJoinMion($criteria, $con, $join_behavior);
			}
		}
		$this->lastMionKategoriaMapCriteria = $criteria;

		return $this->collMionKategoriaMaps;
	}

	
	public function clearMionKategoriaMapPubs()
	{
		$this->collMionKategoriaMapPubs = null; 	}

	
	public function initMionKategoriaMapPubs()
	{
		$this->collMionKategoriaMapPubs = array();
	}

	
	public function getMionKategoriaMapPubs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMionKategoriaMapPubs === null) {
			if ($this->isNew()) {
			   $this->collMionKategoriaMapPubs = array();
			} else {

				$criteria->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->id);

				MionKategoriaMapPubPeer::addSelectColumns($criteria);
				$this->collMionKategoriaMapPubs = MionKategoriaMapPubPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->id);

				MionKategoriaMapPubPeer::addSelectColumns($criteria);
				if (!isset($this->lastMionKategoriaMapPubCriteria) || !$this->lastMionKategoriaMapPubCriteria->equals($criteria)) {
					$this->collMionKategoriaMapPubs = MionKategoriaMapPubPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMionKategoriaMapPubCriteria = $criteria;
		return $this->collMionKategoriaMapPubs;
	}

	
	public function countMionKategoriaMapPubs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collMionKategoriaMapPubs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->id);

				$count = MionKategoriaMapPubPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->id);

				if (!isset($this->lastMionKategoriaMapPubCriteria) || !$this->lastMionKategoriaMapPubCriteria->equals($criteria)) {
					$count = MionKategoriaMapPubPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collMionKategoriaMapPubs);
				}
			} else {
				$count = count($this->collMionKategoriaMapPubs);
			}
		}
		return $count;
	}

	
	public function addMionKategoriaMapPub(MionKategoriaMapPub $l)
	{
		if ($this->collMionKategoriaMapPubs === null) {
			$this->initMionKategoriaMapPubs();
		}
		if (!in_array($l, $this->collMionKategoriaMapPubs, true)) { 			array_push($this->collMionKategoriaMapPubs, $l);
			$l->setMionKategoria($this);
		}
	}


	
	public function getMionKategoriaMapPubsJoinMionPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(MionKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMionKategoriaMapPubs === null) {
			if ($this->isNew()) {
				$this->collMionKategoriaMapPubs = array();
			} else {

				$criteria->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->id);

				$this->collMionKategoriaMapPubs = MionKategoriaMapPubPeer::doSelectJoinMionPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(MionKategoriaMapPubPeer::KATEGORIA_ID, $this->id);

			if (!isset($this->lastMionKategoriaMapPubCriteria) || !$this->lastMionKategoriaMapPubCriteria->equals($criteria)) {
				$this->collMionKategoriaMapPubs = MionKategoriaMapPubPeer::doSelectJoinMionPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastMionKategoriaMapPubCriteria = $criteria;

		return $this->collMionKategoriaMapPubs;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collMionKategoriaMaps) {
				foreach ((array) $this->collMionKategoriaMaps as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collMionKategoriaMapPubs) {
				foreach ((array) $this->collMionKategoriaMapPubs as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collMionKategoriaMaps = null;
		$this->collMionKategoriaMapPubs = null;
	}

} 