<?php


abstract class BaseMionKategoriaMap extends BaseObject  implements Persistent {


  const PEER = 'MionKategoriaMapPeer';

	
	protected static $peer;

	
	protected $mion_id;

	
	protected $kategoria_id;

	
	protected $aMion;

	
	protected $aMionKategoria;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getMionId()
	{
		return $this->mion_id;
	}

	
	public function getKategoriaId()
	{
		return $this->kategoria_id;
	}

	
	public function setMionId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->mion_id !== $v) {
			$this->mion_id = $v;
			$this->modifiedColumns[] = MionKategoriaMapPeer::MION_ID;
		}

		if ($this->aMion !== null && $this->aMion->getId() !== $v) {
			$this->aMion = null;
		}

		return $this;
	} 
	
	public function setKategoriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kategoria_id !== $v) {
			$this->kategoria_id = $v;
			$this->modifiedColumns[] = MionKategoriaMapPeer::KATEGORIA_ID;
		}

		if ($this->aMionKategoria !== null && $this->aMionKategoria->getId() !== $v) {
			$this->aMionKategoria = null;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->mion_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->kategoria_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating MionKategoriaMap object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aMion !== null && $this->mion_id !== $this->aMion->getId()) {
			$this->aMion = null;
		}
		if ($this->aMionKategoria !== null && $this->kategoria_id !== $this->aMionKategoria->getId()) {
			$this->aMionKategoria = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionKategoriaMapPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = MionKategoriaMapPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aMion = null;
			$this->aMionKategoria = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionKategoriaMapPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			MionKategoriaMapPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionKategoriaMapPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			MionKategoriaMapPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aMion !== null) {
				if ($this->aMion->isModified() || $this->aMion->isNew()) {
					$affectedRows += $this->aMion->save($con);
				}
				$this->setMion($this->aMion);
			}

			if ($this->aMionKategoria !== null) {
				if ($this->aMionKategoria->isModified() || $this->aMionKategoria->isNew()) {
					$affectedRows += $this->aMionKategoria->save($con);
				}
				$this->setMionKategoria($this->aMionKategoria);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MionKategoriaMapPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += MionKategoriaMapPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aMion !== null) {
				if (!$this->aMion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMion->getValidationFailures());
				}
			}

			if ($this->aMionKategoria !== null) {
				if (!$this->aMionKategoria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMionKategoria->getValidationFailures());
				}
			}


			if (($retval = MionKategoriaMapPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MionKategoriaMapPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getMionId();
				break;
			case 1:
				return $this->getKategoriaId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = MionKategoriaMapPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getMionId(),
			$keys[1] => $this->getKategoriaId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MionKategoriaMapPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setMionId($value);
				break;
			case 1:
				$this->setKategoriaId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = MionKategoriaMapPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setMionId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setKategoriaId($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(MionKategoriaMapPeer::DATABASE_NAME);

		if ($this->isColumnModified(MionKategoriaMapPeer::MION_ID)) $criteria->add(MionKategoriaMapPeer::MION_ID, $this->mion_id);
		if ($this->isColumnModified(MionKategoriaMapPeer::KATEGORIA_ID)) $criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->kategoria_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(MionKategoriaMapPeer::DATABASE_NAME);

		$criteria->add(MionKategoriaMapPeer::MION_ID, $this->mion_id);
		$criteria->add(MionKategoriaMapPeer::KATEGORIA_ID, $this->kategoria_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getMionId();

		$pks[1] = $this->getKategoriaId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setMionId($keys[0]);

		$this->setKategoriaId($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setMionId($this->mion_id);

		$copyObj->setKategoriaId($this->kategoria_id);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MionKategoriaMapPeer();
		}
		return self::$peer;
	}

	
	public function setMion(Mion $v = null)
	{
		if ($v === null) {
			$this->setMionId(NULL);
		} else {
			$this->setMionId($v->getId());
		}

		$this->aMion = $v;

						if ($v !== null) {
			$v->addMionKategoriaMap($this);
		}

		return $this;
	}


	
	public function getMion(PropelPDO $con = null)
	{
		if ($this->aMion === null && ($this->mion_id !== null)) {
			$c = new Criteria(MionPeer::DATABASE_NAME);
			$c->add(MionPeer::ID, $this->mion_id);
			$this->aMion = MionPeer::doSelectOne($c, $con);
			
		}
		return $this->aMion;
	}

	
	public function setMionKategoria(MionKategoria $v = null)
	{
		if ($v === null) {
			$this->setKategoriaId(NULL);
		} else {
			$this->setKategoriaId($v->getId());
		}

		$this->aMionKategoria = $v;

						if ($v !== null) {
			$v->addMionKategoriaMap($this);
		}

		return $this;
	}


	
	public function getMionKategoria(PropelPDO $con = null)
	{
		if ($this->aMionKategoria === null && ($this->kategoria_id !== null)) {
			$c = new Criteria(MionKategoriaPeer::DATABASE_NAME);
			$c->add(MionKategoriaPeer::ID, $this->kategoria_id);
			$this->aMionKategoria = MionKategoriaPeer::doSelectOne($c, $con);
			
		}
		return $this->aMionKategoria;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aMion = null;
			$this->aMionKategoria = null;
	}

} 