<?php


abstract class BaseMionZalacznik extends BaseObject  implements Persistent {


  const PEER = 'MionZalacznikPeer';

	
	protected static $peer;

	
	protected $mion_id;

	
	protected $zalacznik_id;

	
	protected $zalacznik_kolejnosc;

	
	protected $aMion;

	
	protected $aZalacznik;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->zalacznik_kolejnosc = 0;
	}

	
	public function getMionId()
	{
		return $this->mion_id;
	}

	
	public function getZalacznikId()
	{
		return $this->zalacznik_id;
	}

	
	public function getZalacznikKolejnosc()
	{
		return $this->zalacznik_kolejnosc;
	}

	
	public function setMionId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->mion_id !== $v) {
			$this->mion_id = $v;
			$this->modifiedColumns[] = MionZalacznikPeer::MION_ID;
		}

		if ($this->aMion !== null && $this->aMion->getId() !== $v) {
			$this->aMion = null;
		}

		return $this;
	} 
	
	public function setZalacznikId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->zalacznik_id !== $v) {
			$this->zalacznik_id = $v;
			$this->modifiedColumns[] = MionZalacznikPeer::ZALACZNIK_ID;
		}

		if ($this->aZalacznik !== null && $this->aZalacznik->getId() !== $v) {
			$this->aZalacznik = null;
		}

		return $this;
	} 
	
	public function setZalacznikKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->zalacznik_kolejnosc !== $v || $v === 0) {
			$this->zalacznik_kolejnosc = $v;
			$this->modifiedColumns[] = MionZalacznikPeer::ZALACZNIK_KOLEJNOSC;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC))) {
				return false;
			}

			if ($this->zalacznik_kolejnosc !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->mion_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->zalacznik_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->zalacznik_kolejnosc = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating MionZalacznik object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aMion !== null && $this->mion_id !== $this->aMion->getId()) {
			$this->aMion = null;
		}
		if ($this->aZalacznik !== null && $this->zalacznik_id !== $this->aZalacznik->getId()) {
			$this->aZalacznik = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionZalacznikPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = MionZalacznikPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aMion = null;
			$this->aZalacznik = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionZalacznikPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			MionZalacznikPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MionZalacznikPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			MionZalacznikPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aMion !== null) {
				if ($this->aMion->isModified() || $this->aMion->isNew()) {
					$affectedRows += $this->aMion->save($con);
				}
				$this->setMion($this->aMion);
			}

			if ($this->aZalacznik !== null) {
				if ($this->aZalacznik->isModified() || $this->aZalacznik->isNew()) {
					$affectedRows += $this->aZalacznik->save($con);
				}
				$this->setZalacznik($this->aZalacznik);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MionZalacznikPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += MionZalacznikPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aMion !== null) {
				if (!$this->aMion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMion->getValidationFailures());
				}
			}

			if ($this->aZalacznik !== null) {
				if (!$this->aZalacznik->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aZalacznik->getValidationFailures());
				}
			}


			if (($retval = MionZalacznikPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MionZalacznikPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getMionId();
				break;
			case 1:
				return $this->getZalacznikId();
				break;
			case 2:
				return $this->getZalacznikKolejnosc();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = MionZalacznikPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getMionId(),
			$keys[1] => $this->getZalacznikId(),
			$keys[2] => $this->getZalacznikKolejnosc(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MionZalacznikPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setMionId($value);
				break;
			case 1:
				$this->setZalacznikId($value);
				break;
			case 2:
				$this->setZalacznikKolejnosc($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = MionZalacznikPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setMionId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setZalacznikId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setZalacznikKolejnosc($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(MionZalacznikPeer::DATABASE_NAME);

		if ($this->isColumnModified(MionZalacznikPeer::MION_ID)) $criteria->add(MionZalacznikPeer::MION_ID, $this->mion_id);
		if ($this->isColumnModified(MionZalacznikPeer::ZALACZNIK_ID)) $criteria->add(MionZalacznikPeer::ZALACZNIK_ID, $this->zalacznik_id);
		if ($this->isColumnModified(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC)) $criteria->add(MionZalacznikPeer::ZALACZNIK_KOLEJNOSC, $this->zalacznik_kolejnosc);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(MionZalacznikPeer::DATABASE_NAME);

		$criteria->add(MionZalacznikPeer::MION_ID, $this->mion_id);
		$criteria->add(MionZalacznikPeer::ZALACZNIK_ID, $this->zalacznik_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getMionId();

		$pks[1] = $this->getZalacznikId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setMionId($keys[0]);

		$this->setZalacznikId($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setMionId($this->mion_id);

		$copyObj->setZalacznikId($this->zalacznik_id);

		$copyObj->setZalacznikKolejnosc($this->zalacznik_kolejnosc);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MionZalacznikPeer();
		}
		return self::$peer;
	}

	
	public function setMion(Mion $v = null)
	{
		if ($v === null) {
			$this->setMionId(NULL);
		} else {
			$this->setMionId($v->getId());
		}

		$this->aMion = $v;

						if ($v !== null) {
			$v->addMionZalacznik($this);
		}

		return $this;
	}


	
	public function getMion(PropelPDO $con = null)
	{
		if ($this->aMion === null && ($this->mion_id !== null)) {
			$c = new Criteria(MionPeer::DATABASE_NAME);
			$c->add(MionPeer::ID, $this->mion_id);
			$this->aMion = MionPeer::doSelectOne($c, $con);
			
		}
		return $this->aMion;
	}

	
	public function setZalacznik(Zalacznik $v = null)
	{
		if ($v === null) {
			$this->setZalacznikId(NULL);
		} else {
			$this->setZalacznikId($v->getId());
		}

		$this->aZalacznik = $v;

						if ($v !== null) {
			$v->addMionZalacznik($this);
		}

		return $this;
	}


	
	public function getZalacznik(PropelPDO $con = null)
	{
		if ($this->aZalacznik === null && ($this->zalacznik_id !== null)) {
			$c = new Criteria(ZalacznikPeer::DATABASE_NAME);
			$c->add(ZalacznikPeer::ID, $this->zalacznik_id);
			$this->aZalacznik = ZalacznikPeer::doSelectOne($c, $con);
			
		}
		return $this->aZalacznik;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aMion = null;
			$this->aZalacznik = null;
	}

} 